#include <iostream.h>
#include "paginaWeb1.h"
#include "listaDiStringhe1.h"

const int ESCI = -1;
const int INDIETRO = -2;
const int AVANTI = -3;

void leggiIndirizzoIniziale(string &URI);
void naviga(string URI);
void vaiIndietro (string &URI, lista &avanti, lista &indietro, bool &esito);
void vaiAvanti (string &URI, lista &avanti, lista &indietro, bool &esito);
int leggiScelta(int numeroLink, bool indietro, bool avanti);
bool controlla(int scelta, int numeroLink, bool indietro, bool avanti);

void main() {
    string URI;
    leggiIndirizzoIniziale(URI);
    naviga(URI);
}

void leggiIndirizzoIniziale(string &URI) {
    cout << "*************************************************************\n";
    cout << "              Browser per File Testuali\n";
    cout << "*************************************************************\n";
    cout << "Immetti l'indirizzo del file da cui cominciare la navigazione\n";
    cout << "Indirizzo -> ";
    cin >> URI;
    return;
}

void naviga (string URI) {
    bool continua = true;
    bool esito;
    paginaWeb pagina;
    lista indietro;
    lista avanti;
    inizializza(indietro);
    inizializza(avanti);
    while (continua) {
        caricaPagina(pagina, URI);
        stampaPagina(pagina);
        int scelta = leggiScelta(numeroLink(pagina), !listaVuota(indietro), !listaVuota(avanti));
        if (scelta == ESCI) {
            continua = false;
        } else if (scelta == INDIETRO) {
            vaiIndietro(URI, avanti, indietro, esito);
            if (!esito) {
                cout << "Errore. Operazione scorretta\n";
                continua = false;
            }
        } else if (scelta == AVANTI) {
            vaiAvanti(URI, avanti, indietro, esito);
            if (!esito) {
                cout << "Errore. Operazione scorretta\n";
                continua = false;
            }
        } else {
            aggiungi(indietro, URI, esito);
            if (!esito) {
                cout << "Errore. Operazione scorretta\n";
                continua = false;
            }
            inizializza(avanti);
            URI = indirizzoIesimo(pagina, scelta);
        }
    }
    cout << "\n";
    cout << "------------\n";
    cout << "Arrivederci" << "\n";
}

void vaiIndietro (string &URI, lista &avanti, lista &indietro, bool &esito) {
    bool esito1, esito2;
    aggiungi (avanti, URI, esito1);
    URI = elementoInPosizione(indietro, numeroElementi(indietro) - 1);
    elimina(indietro, esito2);
    esito = esito1 && esito2;
    return;
}

void vaiAvanti (string &URI, lista &avanti, lista &indietro, bool &esito) {
    bool esito1, esito2;
    aggiungi (indietro, URI, esito1);
    URI = elementoInPosizione(avanti, numeroElementi(avanti) - 1);
    elimina(avanti, esito2);
    esito = esito1 && esito2;
    return;
}

int leggiScelta(int numeroLink, bool indietro, bool avanti) {
    int scelta;
    cout << "Comandi disponibili:\n";
    cout << "  " << ESCI << ".\t Esci\n";
    if (indietro) {
        cout << "  " << INDIETRO << ".\t Indietro\n";
    }
    if (avanti) {
        cout << "  " << AVANTI << ". \t Avanti\n";
    }
    cout << "\n";
    cout << "  Scelta -> ";
    cin >> scelta;
    bool ok = controlla(scelta, numeroLink, indietro, avanti);
    while (!ok) {
        cout << "  ** Errore. Scelta Errata\n";
        cout << "  Immetti scelta corretta -> ";
        cin >> scelta;
        ok = controlla(scelta, numeroLink, indietro, avanti);
    }
    return scelta;
}

bool controlla(int scelta, int numeroLink, bool indietro, bool avanti){
    bool ok = false;
    if (scelta == ESCI) {
        ok = true;
    } else if (scelta >= 0 && scelta < numeroLink) {
        ok = true;
    } else if (indietro && scelta == INDIETRO) {
        ok = true;
    } else if (avanti && scelta == AVANTI) {
        ok = true;
    }
    return ok;
}