#include <iostream.h>

const int MAX=100;

int scegliNumero();
void indovinaNumero(int numero);

void schermoFineGioco();
void schermoIniziale();
int schermoMenu(int tentativi);
void schermoInterruzione(int numero, int tentativi);
void schermoIndovinato(int tentativi);
void schermoEsitoGiocata(int numero, int giocata);

void main() {
    int numero;

    numero=scegliNumero();
    indovinaNumero(numero);
}

int scegliNumero() {
    int numero;
    int seed = time(NULL);
    srand(seed);
    numero = rand() % MAX + 1;
    return numero;
}

void indovinaNumero(int numero) {
    int giocata;
    int tentativi=0;
    bool continua=true;

    schermoIniziale();
    while (continua) {
        giocata=schermoMenu(tentativi);
        if (giocata==0) {
            continua=false;
            schermoInterruzione(numero, tentativi);
        } else {
            tentativi++;
            if (giocata == numero) {
                continua=false;
                schermoIndovinato(tentativi);
            } else {
                schermoEsitoGiocata(numero, giocata);
            }
        }
    }
    return;
}

void schermoIniziale() {
    cout << "Indovina il numero \n";
    cout << "-------------------------------------- \n";
    cout << "Devi indovinare un numero tra 1 e " << MAX << "\n";
    cout << "-------------------------------------- \n";
    return;
}

int schermoMenu(int tentativi) {
    int scelta;
    cout << "-------------------------------------- \n";
    cout << "   Tentativi effettuati: " << tentativi << "\n";
    cout << "+-------------------------------------+\n";
    cout << "   Immetti il tuo tentativo \n";
    cout << "   (0 per interrompere) \n";
    cout << "   Tentativo --> ";
    cin >> scelta;
    while ((scelta<0) || (scelta>MAX)) {
        cout << "*****  Errore: Valore scorretto. Nuovo tentativo --> ";
        cin >> scelta;
    }
    return scelta;
}

void schermoInterruzione(int numero, int tentativi) {
    cout << "-------------------------------------- \n";
    cout << "Partita interrotta\n";
    cout << "-------------------------------------- \n";
    cout << "   Il numero era:        " << numero << "\n";
    cout << "   Tentativi effettuati: " << tentativi << "\n";
    cout << "+-------------------------------------+\n";
    return;
}

void schermoIndovinato(int tentativi){
    cout << "-------------------------------------- \n";
    cout << "BRAVO. NUMERO INDOVINATO\n";
    cout << "-------------------------------------- \n";
    cout << "   Tentativi effettuati: " << tentativi << "\n";
    cout << "+-------------------------------------+\n";
    return;
}

void schermoEsitoGiocata(int numero, int giocata) {
    cout << "-------------------------------------- \n";
    cout << "   Tentativo sbagliato\n";
    if (numero>giocata) {
        cout << "   Prova con un numero piu' alto\n";
    } else if (numero<giocata) {
        cout << "   Prova con un numero piu' basso\n";
    }
    cout << "-------------------------------------- \n";
    return;
}