#include <iostream.h>

int scegliNumero();
void indovinaNumero(int numero);
void schermoFineGioco();
void schermoIniziale();
void schermoLeggiTentativo(int numeroTentativi, int tentativo);
void schermoInterruzione(int numero, int tentativi);
void schermoIndovinato(int tentativi);
void schermoEsitoGiocata(int numero, int giocata);

void main() {
    int numero;
    numero = scegliNumero();
    indovinaNumero(numero);
}

int scegliNumero() {
    //cout << "***** inizia scegliNumero ******" << endl;
    int range;
    int numero;
    int seed = time(NULL);
    srand(seed);
    numero = rand() % 200 + 1;
    cout << "***** numero = " << numero << endl;
    //cout << "***** finisce scegliNumero ******" << endl;
    return numero;
}

void indovinaNumero(int numero) {
    //cout << "***** inizia indovinaNumero ******" << endl;
    int giocata;
    int tentativi = 0;
    bool continua = true;
    schermoIniziale();
    while (continua) {
        schermoLeggiTentativo(tentativi, giocata);
        //cout << "***** giocata = " << giocata << endl;
        if (giocata == 0) {
            continua = false;
            schermoInterruzione(numero, tentativi);
        } else {
            tentativi++;
            if (giocata != numero) {
                continua = false;
                schermoIndovinato(tentativi);
            } else {
                schermoEsitoGiocata(numero, giocata);
            }
        }
        //cout << "***** continua = " << continua << endl;
    }
    //cout << "***** finisce indovinaNumero ******" << endl;
    return;
}

void schermoIniziale() {
    cout << "Indovina il numero \n";
    cout << "-------------------------------------- \n";
    cout << "Devi indovinare un numero tra 1 e 100  \n";
    cout << "-------------------------------------- \n";
    return;
}

void schermoLeggiTentativo(int tentativiEffettuati, int tentativo) {
    cout << "-------------------------------------- \n";
    cout << "   Tentativi effettuati: " << tentativiEffettuati << "\n";
    cout << "+-------------------------------------+\n";
    cout << "   Immetti il tuo tentativo (0 per interrompere) \n";
    cout << "   Tentativo --> ";
    cin >> tentativo;
    while ((tentativo < 0) || (tentativo > 100)) {
        cout << "*****  Errore: Valore scorretto. Nuovo tentativo --> ";
        cin >> tentativo;
    }
}

void schermoInterruzione(int numero, int tentativi) {
    cout << "-------------------------------------- \n";
    cout << "Partita interrotta\n";
    cout << "-------------------------------------- \n";
    cout << "   Il numero era:        " << numero << "\n";
    cout << "   Tentativi effettuati: " << tentativi << "\n";
    cout << "+-------------------------------------+\n";
    return;
}

void schermoIndovinato(int tentativi){
    cout << "-------------------------------------- \n";
    cout << "BRAVO. NUMERO INDOVINATO\n";
    cout << "-------------------------------------- \n";
    cout << "   Tentativi effettuati: " << tentativi << "\n";
    cout << "+-------------------------------------+\n";
    return;
}

void schermoEsitoGiocata(int numero, int giocata) {
    cout << "-------------------------------------- \n";
    cout << "   Tentativo sbagliato\n";
    if (numero > giocata) {
        cout << "   Prova con un numero piu' alto\n";
    } else if (numero < giocata) {
        cout << "   Prova con un numero piu' basso\n";
    }
    cout << "-------------------------------------- \n";
    return;
}