/*
  listaDiStringhe1.h
  ----------------
  file delle intestazioni di una libreria per la gestione di liste
  di stringhe rappresentate con array e indicatore di riempimento

  Nota: la libreria e' stata scritta esclusivamente a scopo didattico
  http://www.difa.unibas.it/users/gmecca/corsi/informatica
*/

//COSTANTI GLOBALI:
//-----------------
  const int MAXDIM=100;
  //--> dimensione massima dell'insieme di numeri reali

//MODELLO DI STRUTTURA
  struct lista {
      int indicatore;
      string valori[MAXDIM];
  };

//PROCEDURE:
//----------
  void inizializza (lista &l);
  //--> inizializza la lista l alla lista vuota
  //lista &l --> la lista

  void leggi (lista &l);
  //--> effettua la lettura dei valori della lista l dalla tastiera
  //lista &l --> la lista

  void stampa (lista l);
  //--> effettua la stampa dei valori della lista l sullo schermo
  //lista l --> la lista

  void salvaSuDisco (lista l, string nomeFile);
  //--> salva i valori della lista l in un file
  //lista l --> la lista
  //string nomeFile --> il nome del file

  void carica (lista &l, string nomeFile);
  //--> carica i valori della lista l da un file
  //lista &l --> la lista
  //string nomeFile --> il nome del file

  void aggiungi (lista &l, string elem, bool& esito);
  //--> aggiunge "elem" in coda ai valori della lista l se
  //    questo e' possibile; "esito" segnala la riuscita
  //    dell'operazione
  //lista &l --> la lista
  //string elem    --> elemento da aggiungere
  //bool esito--> segnala l'esito dell'operazione

  void aggiungi (lista &l, string elem, int pos, bool& esito);
  //--> aggiunge "elem" ai valori della lista l in posizione pos se
  //    questo e' possibile; "esito" segnala la riuscita
  //    dell'operazione
  //lista &l --> la lista
  //string elem    --> elemento da aggiungere
  //int pos  --> posizione in cui aggiungere
  //bool esito--> segnala l'esito dell'operazione

  void elimina (lista &l, bool& esito);
  //--> elimina l'elemento in coda alla lista l se
  //    questo e' possibile; "esito" segnala la riuscita
  //  dell'operazione
  //lista &l --> la lista
  //bool esito--> segnala l'esito dell'operazione

  void elimina (lista &l, int pos, bool& esito);
  //--> elimina un elemento in posizione "pos" dalla lista l se
  //    questo e' possibile; "esito" segnala la riuscita
  //  dell'operazione
  //lista &l --> la lista
  //int pos  --> posizione in cui aggiungere
  //bool esito--> segnala l'esito dell'operazione

//FUNZIONI:
//---------

  int numeroElementi (lista l);
  //--> restitituisce il numero di elementi della lista l
  //lista l --> la lista

  string elementoInPosizione (lista l, int pos);
  //--> restituisce l'elemento in posizione pos
  //lista l --> la lista
  //int pos --> elemento da cercare
  //NOTA: si assume che pos sia minore del numero di elementi
  //      della lista, altrimenti si genera un errore

  int cercaPosizione (lista l, string elem);
  //--> se "elem" e' contenuto nella lista l ne restituisce
  //    la posizione; -1 altrimenti; nel caso l'insieme
  //    "ins" contenga piu' occorrenze di "elem", viene
  //    restituita la posizione della prima occorrenza
  //lista l --> la lista
  //string elem    --> elemento da cercare

  bool listaVuota (lista l);
  //--> restituisce true se la lista e' priva di elementi
  //lista l --> la lista

  bool listaPiena (lista l);
  //--> restituisce true se la lista e' completamente piena
  //lista l --> la lista
