// programma per giocare alla morra cinese
// versione con sottoprogrammi
// + menu semplificati

#include <iostream.h>

const int MANI=3;

void inizioGioco(string& nome);
void gioca(string nome);
void nuovaPartita(string nome, int& vittorieComputer, int& vittorieGiocatore);
void nuovaMano(string nome, int giocataComputer, int& punteggioComputer, int& punteggioGiocatore, int&pareggi);
int generaGiocataComputer();
int controllaEsito(int giocataComputer, int giocataGiocatore);
string giocata(int numero);

// schermi
void schermoIniziale(string& nome);
int schermoMenuPrincipale(string nome);
int schermoMenuPartita(string nome, int punteggioComputer, int punteggioGiocatore, int pareggi);
void schermoEsitoPartita(string nome, int punteggioComputer, int punteggioGiocatore, int pareggi);
void schermoEsitoMano(string nome, int esito, int giocataComputer, int giocataGiocatore);
void schermoVittorie(string nome, int vittorieComputer, int vittorieGiocatore);
void schermoFinale(string nome);

void main() {
    string nome;

    inizioGioco(nome);
    gioca(nome);
    schermoFinale(nome);
}

void inizioGioco(string& nome) {
    // istruzioni necessarie per la generazione di numeri casuali
    unsigned seed = time(NULL);
    srand(seed);

    schermoIniziale(nome);
    return;
}

void gioca(string nome) {
    int vittorieComputer=0, vittorieGiocatore=0;
    int scelta;
    bool continua=true;
    while (continua) {
        scelta = schermoMenuPrincipale(nome);
        if (scelta==1)
            nuovaPartita(nome, vittorieComputer, vittorieGiocatore);
        else if (scelta==2)
            schermoVittorie(nome, vittorieComputer, vittorieGiocatore);
        else
            continua=false;
    }
    return;
}

void nuovaPartita(string nome, int& vittorieComputer, int& vittorieGiocatore) {
    int punteggioComputer=0, punteggioGiocatore=0, pareggi=0;
    int giocataGiocatore;
    bool continua=true;
    while (continua) {
        giocataGiocatore = schermoMenuPartita(nome, punteggioComputer, punteggioGiocatore, pareggi);
        if (giocataGiocatore>0) {
            nuovaMano(nome, giocataGiocatore, punteggioComputer, punteggioGiocatore, pareggi);
            if ((punteggioComputer==MANI) || (punteggioGiocatore==MANI)) {
                if (punteggioComputer==MANI)
                    vittorieComputer++;
                else
                    vittorieGiocatore++;
                schermoEsitoPartita(nome, punteggioComputer, punteggioGiocatore, pareggi);
                continua=false;
            }
        } else
            continua=false;
    }
    return;
}

void nuovaMano(string nome, int giocataGiocatore, int& punteggioComputer, int& punteggioGiocatore, int& pareggi) {
    int giocataComputer;
    int esito;
    giocataComputer = generaGiocataComputer();
    esito = controllaEsito(giocataComputer, giocataGiocatore);
    schermoEsitoMano(nome, esito, giocataComputer, giocataGiocatore);
    if (esito==1)
        punteggioComputer++;
    else if (esito==2)
        punteggioGiocatore++;
    else
        pareggi++;
    return;

}

int generaGiocataComputer() {
    int giocata;
    giocata = rand() % 3 + 1;
    return giocata;
}

int controllaEsito(int giocataComputer, int giocataGiocatore) {
    int esito=1; // vince il computer
    if (giocataGiocatore==giocataComputer)
        esito=3;
    else if ((giocataGiocatore==1) && (giocataComputer==3))
        esito=2;
    else if ((giocataGiocatore==2) && (giocataComputer==1))
        esito=2;
    else if ((giocataGiocatore==3) && (giocataComputer==2))
        esito=2;
    return esito;
}

string giocata(int numero) {
    string s;
    if (numero==1)
        s="carta";
    else if (numero==2)
        s="forbici";
    else if (numero==3)
        s="sasso";
    return s;
}

void schermoIniziale(string& nome) {
    cout << "Benvenuto nella Morra Cinese \n";
    cout << "-------------------------------------- \n";
    cout << "Immetti il tuo nome per iniziare il gioco: ";
    getline(cin, nome);
    cout << "+-------------------------------------+\n";
    cout << "   Benvenuto, " << nome << "\n";
    cout << "+-------------------------------------+\n";
    return;
}

int schermoMenuPrincipale(string nome) {
    int scelta;
    cout << "+-------------------------------------+\n";
    cout << "|  1. Nuova Partita                   |\n";
    cout << "|  2. Visualizza Vittorie             |\n";
    cout << "|  3. Esci dal Gioco                  |\n";
    cout << "+-------------------------------------+\n";
    cout << "   Scelta --> ";
    cin >> scelta;
    while ((scelta<1) || (scelta>3)) {
        cout << "*****  Errore: Scelta scorretta. Nuova scelta --> ";
        cin >> scelta;
    }
    return scelta;
}

int schermoMenuPartita(string nome, int punteggioComputer, int punteggioGiocatore, int pareggi) {
    int scelta;
    cout << "+-------------------------------------+\n";
    cout << "   " << nome << ": punti " << punteggioGiocatore << "\n";
    cout << "   Computer: punti " << punteggioComputer << "\n";
    cout << "   Pareggi: " << pareggi << "\n";
    cout << "+-------------------------------------+\n";
    cout << "+-------------------------------------+\n";
    cout << "  " << nome << ", inserisci la tua giocata\n";
    cout << "+-------------------------------------+\n";
    cout << "|  1. carta                           |\n";
    cout << "|  2. forbici                         |\n";
    cout << "|  3. sasso                           |\n";
    cout << "|                                     |\n";
    cout << "|  0. Interrompi partita              |\n";
    cout << "+-------------------------------------+\n";
    cout << "   Scelta --> ";
    cin >> scelta;
    while ((scelta<0) || (scelta>3)) {
        cout << "*****  Errore: Scelta scorretta. Nuova scelta ? ";
        cin >> scelta;
    }
    return scelta;
}

void schermoEsitoPartita(string nome, int punteggioComputer, int punteggioGiocatore, int pareggi) {
    cout << "+-------------------------------------+\n";
    cout << "  " << nome << " hai vinto " << punteggioGiocatore << " mani\n";
    cout << "  Il computer ha vinto " << punteggioComputer << " mani\n";
    cout << "  Ci sono stati " << pareggi << " pareggi\n";
    cout << "+-------------------------------------+\n";
    if (punteggioGiocatore>punteggioComputer)
        cout << "  Bravo, " << nome << " hai vinto la partita\n";
    else
        cout << "  Peccato, " << nome << " hai perso la partita\n";
    cout << "+-------------------------------------+\n";
    return;
}

void schermoEsitoMano(string nome, int esito, int giocataComputer, int giocataGiocatore) {
    cout << "+-------------------------------------+\n";
    cout << "  " << nome << ", hai giocato " << giocata(giocataGiocatore) << "\n";
    cout << "  Il computer ha giocato " << giocata(giocataComputer) << "\n";
    cout << endl;
    if (esito==1)
        cout << "  Peccato, " << nome << " hai perso la mano\n";
    else if (esito==2)
        cout << "  Bravo, " << nome << " hai vinto la mano\n";
    else
        cout << "  Si e' verificato un pareggio\n";
    cout << "+-------------------------------------+\n";
    return;
}

void schermoVittorie(string nome, int vittorieComputer, int vittorieGiocatore) {
    cout << "+-------------------------------------+\n";
    cout << "  " << nome << " hai vinto " << vittorieGiocatore << " partite\n";
    cout << "  Il computer ha vinto " << vittorieComputer << " partite\n";
    cout << "+-------------------------------------+\n";
    return;
}

void schermoFinale(string nome) {
    cout << "Arrivederci, " << nome << "\n";
    return;
}
