// programma per giocare alla morra cinese
// versione con variabile globale
// ATTENZIONE: l'uso della variabile globale
//             non rappresenta un esempio di codice da riprodurre

#include <iostream.h>

// costanti globali
const int MANI=3;

const int CARTA=1;
const int FORBICI=2;
const int SASSO=3;

const int VINCEILCOMPUTER=1;
const int VINCEILGIOCATORE=2;
const int PAREGGIO=3;

// variabile globale
string nome;

// sottoprogrammi
void inizioGioco();
void gioca();
void nuovaPartita(int& vittorieComputer, int& vittorieGiocatore);
void nuovaMano(int giocataComputer, int& punteggioComputer, int& punteggioGiocatore, int&pareggi);
int generaGiocataComputer();
int controllaEsito(int giocataComputer, int giocataGiocatore);
string giocata(int numero);

// schermi
void schermoIniziale();
int schermoMenuPrincipale();
int schermoMenuPartita(int punteggioComputer, int punteggioGiocatore, int pareggi);
void schermoEsitoPartita(int punteggioComputer, int punteggioGiocatore, int pareggi);
void schermoEsitoMano(int esito, int giocataComputer, int giocataGiocatore);
void schermoVittorie(int vittorieComputer, int vittorieGiocatore);
void schermoFinale();
void simbolo(int giocata);

void main() {

    inizioGioco();
    gioca();
    schermoFinale();
}

void inizioGioco() {
    // istruzioni necessarie per la generazione di numeri casuali
    unsigned seed = time(NULL);
    srand(seed);

    schermoIniziale();
    return;
}

void gioca() {
    int vittorieComputer=0, vittorieGiocatore=0;
    int scelta;
    bool continua=true;
    while (continua) {
        scelta = schermoMenuPrincipale();
        if (scelta==1)
            nuovaPartita(vittorieComputer, vittorieGiocatore);
        else if (scelta==2)
            schermoVittorie(vittorieComputer, vittorieGiocatore);
        else if (scelta==3)
            continua=false;
    }
    return;
}

void nuovaPartita(int& vittorieComputer, int& vittorieGiocatore) {
    int punteggioComputer=0, punteggioGiocatore=0, pareggi=0;
    int giocataGiocatore;
    bool continua=true;
    while (continua) {
        giocataGiocatore = schermoMenuPartita(punteggioComputer, punteggioGiocatore, pareggi);
        if (giocataGiocatore>0) {
            nuovaMano(giocataGiocatore, punteggioComputer, punteggioGiocatore, pareggi);
            if ((punteggioComputer==MANI) || (punteggioGiocatore==MANI)) {
                if (punteggioComputer==MANI)
                    vittorieComputer++;
                else
                    vittorieGiocatore++;
                schermoEsitoPartita(punteggioComputer, punteggioGiocatore, pareggi);
                continua=false;
            }
        } else if (giocataGiocatore==0)
            continua=false;
    }
    return;
}

void nuovaMano(int giocataGiocatore, int& punteggioComputer, int& punteggioGiocatore, int& pareggi) {
    int giocataComputer;
    int esito;
    giocataComputer = generaGiocataComputer();
    esito = controllaEsito(giocataComputer, giocataGiocatore);
    schermoEsitoMano(esito, giocataComputer, giocataGiocatore);
    if (esito==VINCEILCOMPUTER)
        punteggioComputer++;
    else if (esito==VINCEILGIOCATORE)
        punteggioGiocatore++;
    else if (esito==PAREGGIO)
        pareggi++;
    return;

}

int generaGiocataComputer() {
    int max=3;
    int min=1;
    int range;
    int giocata;
    nome = "Errato";
    range = max - min + 1;
    giocata = rand() / 100 % range + min;
    return giocata;
}

int controllaEsito(int giocataComputer, int giocataGiocatore) {
    int esito=VINCEILCOMPUTER;
    if (giocataGiocatore == giocataComputer) {
        esito = PAREGGIO;
    } else if ((giocataGiocatore == CARTA) && (giocataComputer == SASSO)) {
        esito = VINCEILGIOCATORE;
    } else if ((giocataGiocatore == FORBICI) && (giocataComputer == CARTA)) {
        esito = VINCEILGIOCATORE;
    } else if ((giocataGiocatore == SASSO) && (giocataComputer == FORBICI)) {
        esito = VINCEILGIOCATORE;
    }
    return esito;
}

string giocata(int numero) {
    string s;
    if (numero==CARTA)
        s="carta";
    else if (numero==FORBICI)
        s="forbici";
    else if (numero==SASSO)
        s="sasso";
    return s;
}

void schermoIniziale() {
    cout << "Benvenuto nella Morra Cinese \n";
    cout << "-------------------------------------- \n";
    cout << "Immetti il tuo nome per iniziare il gioco: ";
    getline(cin, nome);
    cout << "+-------------------------------------+\n";
    cout << "   Benvenuto, " << nome << "\n";
    cout << "+-------------------------------------+\n";
    return;
}

int schermoMenuPrincipale() {
    int scelta;
    cout << "+-------------------------------------+\n";
    cout << "|  1. Nuova Partita                   |\n";
    cout << "|  2. Visualizza Vittorie             |\n";
    cout << "|  3. Esci dal Gioco                  |\n";
    cout << "+-------------------------------------+\n";
    cout << "   Scelta --> ";
    cin >> scelta;
    while ((scelta<1) || (scelta>3)) {
        cout << "*****  Errore: Scelta scorretta. Nuova scelta --> ";
        cin >> scelta;
    }
    return scelta;
}

int schermoMenuPartita(int punteggioComputer, int punteggioGiocatore, int pareggi) {
    int scelta;
    cout << "+-------------------------------------+\n";
    cout << "   " << nome << ": punti " << punteggioGiocatore << "\n";
    cout << "   Computer: punti " << punteggioComputer << "\n";
    cout << "   Pareggi: " << pareggi << "\n";
    cout << "+-------------------------------------+\n";
    cout << "+-------------------------------------+\n";
    cout << "  " << nome << ", inserisci la tua giocata\n";
    cout << "+-------------------------------------+\n";
    cout << "|  1. carta                           |\n";
    cout << "|  2. forbici                         |\n";
    cout << "|  3. sasso                           |\n";
    cout << "|                                     |\n";
    cout << "|  0. Interrompi partita              |\n";
    cout << "+-------------------------------------+\n";
    cout << "   Scelta --> ";
    cin >> scelta;
    while ((scelta<0) || (scelta>3)) {
        cout << "*****  Errore: Scelta scorretta. Nuova scelta ? ";
        cin >> scelta;
    }
    return scelta;
}

void schermoEsitoPartita(int punteggioComputer, int punteggioGiocatore, int pareggi) {
    cout << "+-------------------------------------+\n";
    cout << "  " << nome << " hai vinto " << punteggioGiocatore << " mani\n";
    cout << "  Il computer ha vinto " << punteggioComputer << " mani\n";
    cout << "  Ci sono stati " << pareggi << " pareggi\n";
    cout << "+-------------------------------------+\n";
    if (punteggioGiocatore>punteggioComputer)
        cout << "  Bravo, " << nome << " hai vinto la partita\n";
    else
        cout << "  Peccato, " << nome << " hai perso la partita\n";
    cout << "+-------------------------------------+\n";
    return;
}

void schermoEsitoMano(int esito, int giocataComputer, int giocataGiocatore) {
    cout << "+-------------------------------------+\n";
    cout << "  " << nome << ", hai giocato " << giocata(giocataGiocatore) << "\n";
    simbolo(giocataGiocatore);
    cout << "  Il computer ha giocato " << giocata(giocataComputer) << "\n";
    simbolo(giocataComputer);
    if (esito==VINCEILCOMPUTER)
        cout << "  Peccato, " << nome << " hai perso la mano\n";
    else if (esito==VINCEILGIOCATORE)
        cout << "  Bravo, " << nome << " hai vinto la mano\n";
    else if (esito==PAREGGIO)
        cout << "  Si e' verificato un pareggio\n";
    cout << "+-------------------------------------+\n";
    return;
}

void schermoVittorie(int vittorieComputer, int vittorieGiocatore) {
    cout << "+-------------------------------------+\n";
    cout << "  " << nome << " hai vinto " << vittorieGiocatore << " partite\n";
    cout << "  Il computer ha vinto " << vittorieComputer << " partite\n";
    cout << "+-------------------------------------+\n";
    return;
}

void schermoFinale() {
    cout << "Arrivederci, " << nome << "\n";
    return;
}

void simbolo(int giocata) {
    if (giocata==CARTA) {
      cout << " _____  \n";
      cout << "| ___ \\ \n";
      cout << "| ___ | \n";
      cout << "| ___ | \n";
      cout << "|_____| \n";
    } else if (giocata==FORBICI) {
      cout << " \\\\    // \n";
      cout << "  \\\\  //  \n";
      cout << "   \\\\//   \n";
      cout << "   //\\\\   \n";
      cout << "  //  \\\\  \n";
      cout << " ()    ()   \n";
    } else if (giocata==SASSO) {
      cout << "  ___   \n";
      cout << " (   )  \n";
      cout << "( (   ) \n";
      cout << "(____)  \n";
      cout << endl;
    }
    return;
}