#include <iostream.h>

const int N = 3;

const int INCORSO = 0;
const int VINCEILGIOCATORE1 = 1;
const int VINCEILGIOCATORE2 = 2;
const int PAREGGIO = 3;
const int INTERROTTA = 4;
const char GIOCATORE1 = 'X';
const char GIOCATORE2 = 'O';

void inizializza(char scacchiera[N][N]);
void partita(char scacchiera[N][N]);
int mossa(char scacchiera[N][N], char mano);
void esegui(char scacchiera[N][N], int mossa, char simbolo, bool& sceltaAmmessa);
int controllaStato(char scacchiera[N][N], int mossa);
void trasponi(char scacchiera[N][N], char trasposta[N][N]);
bool controlloOrizzontale(char scacchiera[N][N], int x, int y);
bool controlloDiagonale(char scacchiera[N][N], int x, int y, int verso);
int sceltaComputer(char scacchiera[N][N]);
int numeroPosizioniLibere(char scacchiera[N][N]);
int primaPosizioneLibera(char scacchiera[N][N]);

void schermoInizioGioco();
int schermoMossa(char scacchiera[N][N]);
void stampaScacchiera(char scacchiera[N][N]);
void schermoStampaEsito(char scacchiera[N][N], int stato);

void main() {
    char scacchiera[N][N];
    inizializza(scacchiera);
    schermoInizioGioco();
    partita(scacchiera);
}

void inizializza(char scacchiera[N][N]){
    int i, j;
    for (i = 0; i < N; i++) {
        for (j = 0; j < N; j++) {
            scacchiera[i][j] = ' ';
        }
    }
    return;
}

void partita(char scacchiera[N][N]){
    int stato = INCORSO;
    while (stato == INCORSO) {
        cout << "\nMossa del Giocatore n. 1" << endl;
        stato = mossa(scacchiera, GIOCATORE1);
        if (stato == INCORSO) {
            cout << "\nMossa del Giocatore n. 2" << endl;
            stato = mossa(scacchiera, GIOCATORE2);
        }
    }
    schermoStampaEsito(scacchiera, stato);
    return;
}

int mossa(char scacchiera[N][N], char simbolo){
    int stato;
    int scelta;
    bool sceltaAmmessa = false;
    while (!sceltaAmmessa) {
        scelta = schermoMossa(scacchiera);
        if (scelta == -1) {
            sceltaAmmessa = true;
        } else {
            esegui(scacchiera, scelta, simbolo, sceltaAmmessa);
        }
    }
    stato = controllaStato(scacchiera, scelta);
    return stato;
}

void esegui(char scacchiera[N][N], int mossa, char simbolo, bool &esito){
    esito = false;
    int x, y;
    x = mossa / N;
    y = mossa % N;
    if (scacchiera[x][y] == ' '){
        esito = true;
        scacchiera[x][y] = simbolo;
    }
    return;
}

int controllaStato(char scacchiera[N][N], int mossa){
    int stato = INCORSO;
    int x, y;
    char simbolo;
    char trasposta[N][N];
    bool tris;
    if (mossa == -1) {
        stato = INTERROTTA;
    } else if (numeroPosizioniLibere(scacchiera) == 0) {
        stato = PAREGGIO;
    } else {
        x = mossa / N;
        y = mossa % N;
        simbolo = scacchiera[x][y];
        trasponi(scacchiera, trasposta);
        tris = (controlloOrizzontale(scacchiera, x, y) ||
                controlloOrizzontale(trasposta, y, x) ||
                controlloDiagonale(scacchiera, x, y, 1) ||
                controlloDiagonale(scacchiera, x, y, -1));
        if (tris) {
            if (simbolo == GIOCATORE1) {
                stato = VINCEILGIOCATORE1;
            } else {
                stato = VINCEILGIOCATORE2;
            }
        }
    }
    return stato;
}

void trasponi(char scacchiera[N][N], char trasposta[N][N]){
    int i, j;
    for (i = 0; i < N; i++) {
        for (j = 0; j < N; j++) {
            trasposta[i][j] = scacchiera[j][i];
        }
    }
    return;
}

bool controlloOrizzontale(char scacchiera[N][N], int x, int y){
    bool tris = false;
    char simbolo = scacchiera[x][y];
    int j;
    int conta = 0;
    for (j = y - 2; j <= y + 2; j++) {
        if (j >= 0 && j < N) {
            if (scacchiera[x][j] == simbolo) {
                conta++;
            }
        }
    }
    if (conta == N) {
        tris = true;
    }
    return tris;
}


bool controlloDiagonale(char scacchiera[N][N], int x, int y, int verso){
    bool tris=false;
    char simbolo = scacchiera[x][y];
    int i;
    int conta = 0;
    for (i = -2; i <= 2; i++) {
        if ((x + i >= 0) && (x + i < N) && (y + i * verso >= 0) && (y + i * verso < N)) {
            if (scacchiera[x + i][y + i * verso] == simbolo) {
                conta++;
            }
        }
    }
    if (conta == N) {
        tris = true;
    }
    return tris;
}

int numeroPosizioniLibere(char scacchiera[N][N]){
    int i, j;
    int conta = 0;
    for (i = 0; i < N; i++) {
        for (j = 0; j < N; j++) {
            if (scacchiera[i][j] == ' ') {
                conta++;
            }
        }
    }
    return conta;
}

int primaPosizioneLibera(char scacchiera[N][N]){
    int i, j;
    int p;
    for (i = 0; i < N; i++) {
        for (j = 0; j < N; j++) {
            if (scacchiera[i][j] == ' ') {
                p = i * N + j;
                return p;
            }
        }
    }
    return -1;
}

void schermoInizioGioco() {
    cout << "\n";
    cout << "------------------------------------ \n";
    cout << "            T R I S                  \n";
    cout << "------------------------------------ \n";
    cout << "\n";
    cout << "Giocatore n. 1: X \n";
    cout << "Giocatore n. 2: o \n";
    cout << "\n";
    return;
}

int schermoMossa(char scacchiera[N][N]){
    int p;
    stampaScacchiera(scacchiera);
    cout << "\nMossa (-1 per interrompere) --> ";
    cin >> p;
    while (p < -1 || p > N * N) {
        cout << "Errore. Mossa -->";
        cin >> p;
    }
    return p;
}

void stampaScacchiera(char scacchiera[N][N]){
    int i,j;
    cout << "-------------------" << endl;
    for (i = 0; i < 4 * N; i++) {
        for (j = 0; j < N; j++) {
            if (i % 4 == 0) {   //|7
                cout << "|" << (i / 4) * N + j << "    ";
            } else if (i % 4 == 1) {
                cout << "|  " << scacchiera[i / 4][j] << "  ";
            } else if (i % 4 == 2) {
                cout << "|     ";
            } else if (i % 4 == 3) {
                cout << "------";
            }
        }
        cout << "|" << endl;
    }
    return;
}

void schermoStampaEsito(char scacchiera[N][N], int stato){
    stampaScacchiera(scacchiera);
    if (stato == VINCEILGIOCATORE1) {
        cout <<"\nIl Giocatore n.1 ha vinto la partita\n";
    } else if (stato == VINCEILGIOCATORE2) {
        cout <<"\nIl Giocatore n.2 ha vinto la partita\n";
    } else if (stato == PAREGGIO) {
        cout <<"\nC'e' stato un pareggio\n";
    }
    cout << "\n";
    return;
}
