#include <iostream.h>

#include "listaDiReali2.h"
//#include "listaPtr1.h"

void stampaMenu(int &scelta);
int leggiNumeroPositivo();
void aggiungiInOrdine(lista& l, int elem, bool& esito);
void eliminaDuplicati(lista& l);
int contaOccorrenze(lista l, int elem);
int cercaPosizioneOrdinata(lista l, int elem);

void main() {
    lista l;
    int scelta, pos, temp;
    bool continua, esito;
    float elem;
    string nomeFile;

    inizializza(l);
    continua=true;
    while (continua) {
        stampaMenu (scelta);
        switch (scelta) {
            case 0: {
                continua = false;
                break;
            }
            case 1: {
                inizializza(l);
                break;
            }
            case 2: {
                stampa (l);
                break;
            }
            case 3: {
                cout << "\nImmetti il nome del file: ";
                cin >> nomeFile;
                salvaSuDisco(l, nomeFile);
                break;
            }
            case 4: {
                cout << "\nImmetti il nome del file: ";
                cin >> nomeFile;
                carica(l, nomeFile);
                break;
            }
            case 5: {
                cout << "\nNumero di elementi: " << numeroElementi(l) << endl;
                break;
            }
            case 6: {
                cout <<  "\nImmetti il numero della figurina: ";
                elem = leggiNumeroPositivo();
                temp = cercaPosizione (l, elem);
                if (temp != -1) {
                    cout << endl;
                    cout <<  "Elemento contenuto in posizione " << temp << endl;
                } else {
                     cout <<  "Elemento non contenuto nell'archivio\n";
                }
                break;
            }
            case 7: {
                cout << "\nImmetti il numero della figurina da aggiungere: ";
                elem = leggiNumeroPositivo();
                aggiungiInOrdine (l, elem, esito);
                if (!esito) {
                    cout << "\n--- Si e' verificato un errore. ---\n";
                    cout << "---     Operazione Abortita      ---\n\n";
                }
                break;
            }
            case 8: {
                cout <<  "\nImmetti la posizione della figurina: ";
                pos = leggiNumeroPositivo();
                elimina (l, pos, esito);
                if (!esito) {
                    cout <<  "\n--- Si e' verificato un errore.\n";
                    cout <<  "---     Operazione Abortita      ---\n\n";
                }
                break;
            }
            case 9: {
                eliminaDuplicati(l);
                break;
            }
            default: {
                cout << "Operazione non consentita\n";
            }
        }
    }
}

int leggiNumeroPositivo() {
    int numero;
    cin >> numero;
    while (numero < 0) {
        cout << "** Errore: il valore deve essere positivo\n";
        cout << "Immetti valore corretto: ";
        cin >> numero;
    }
    return numero;
}

void stampaMenu (int &scelta) {
      cout << "\n";
      cout <<  "----------------------------------" << endl;
      cout <<  "   Gestione Archivio di Figurine          " << endl;
      cout <<  "----------------------------------" << endl;
      cout << endl;
      cout <<  " 1. Inizializza l'archivio di figurine" << endl;
      cout <<  " 2. Stampa l'archivio di figurine" << endl;
      cout <<  " 3. Salva l'archivio di figurine in un file" << endl;
      cout <<  " 4. Carica l'archivio di figurine da file" << endl;
      cout <<  " 5. Stampa il numero di figurine" << endl;
      cout <<  " 6. Cerca una figurina" << endl;
      cout <<  " 7. Aggiungi una figurina" << endl;
      cout <<  " 8. Elimina una figurina" << endl;
      cout <<  " 9. Elimina doppioni" << endl;
      cout << endl;
      cout <<  " 0. Esci dal programma" << endl;
      cout << endl;
      cout <<  " Scelta --> ";
      cin >> scelta;
      while ((scelta < 0) || (scelta > 9)) {
          cout <<  "Scelta scorretta. Ripetere" << endl;
          cout <<  "Scelta --> " << endl;
          cin >> scelta;
      }
      return;
}

void aggiungiInOrdine(lista& l, int elem, bool& esito) {
    int posizione = cercaPosizioneOrdinata(l, elem);
    aggiungi (l, elem, posizione, esito);
    return;
}

int cercaPosizioneOrdinata(lista l, int elem) {
    if (numeroElementi(l) == 0 || (elem < elementoInPosizione(l, 0))) {
        return 0;
    } else {
        for (int i = 0; i < numeroElementi(l) - 1; i++) {
            if ((elem >= elementoInPosizione(l, i)) && (elem <= elementoInPosizione(l, i + 1))) {
                return i + 1;
            }
        }
    }
    return numeroElementi(l);
}

void eliminaDuplicati(lista& l) {
    int i = 0;
    bool esito;
    while (i < numeroElementi(l)) {
        if (contaOccorrenze(l, elementoInPosizione(l, i)) > 1) {
            elimina (l, i, esito);
        } else {
            i++;
        }
    }
    return;
}

int contaOccorrenze(lista l, int elem) {
    int conta = 0;
    for (int i = 0; i < numeroElementi(l); i++) {
        if (elementoInPosizione(l, i) == (float)elem) {
            conta++;
        }
    }
    return conta;
}

