#include <iostream.h>

const int N = 5;

int schermoMenu();
int schermoLeggiIndice();
void leggiMatrice(int matrice[N][N]);
void stampaMatrice(int matrice[N][N]);

void generaMatriceTriangolare(int matrice[N][N], int valore);
void generaMatriceDiagonale(int matrice[N][N], int valore);
int sommaElementi(int matrice[N][N]);
int sommaDiagonale(int matrice[N][N]);
int sommaRiga(int matrice[N][N], int riga);
int sommaColonna(int matrice[N][N], int colonna);

void main() {
    int matrice[N][N];
    bool continua = true;
    int scelta, riga, colonna;
    int valore;
    while (continua) {
        scelta = schermoMenu();
        if (scelta == 0) {
            continua = false;
        } else if (scelta == 1) {
            cout << "Immetti i dati della matrice quadrata" << endl;
            leggiMatrice(matrice);
        } else if (scelta == 2) {
            cout << "Inserisci valore di riempimento: ";
            cin >> valore;
            generaMatriceTriangolare(matrice, valore);
        } else if (scelta == 3) {
            cout << "Inserisci valore di riempimento: ";
            cin >> valore;
            generaMatriceDiagonale(matrice, valore);
        } else if (scelta == 4) {
            stampaMatrice(matrice);
        } else if (scelta == 5) {
            cout << "La somma degli elementi vale: " << sommaElementi(matrice) << "\n";
        } else if (scelta == 6) {
            cout << "La somma della diagonale vale: " << sommaDiagonale(matrice) << "\n";
        } else if (scelta == 7) {
            cout << "Quale riga vuoi analizzare ?" << endl;
            riga = schermoLeggiIndice();
            cout << "La somma dei valori sulla riga " << riga << " vale: "
                 << sommaRiga(matrice, riga) << "\n";
        } else if (scelta == 8) {
            cout << "Quale colonna vuoi analizzare ?" << endl;
            colonna = schermoLeggiIndice();
            cout << "La somma dei valori sulla colonna " << colonna << " vale: "
                 << sommaColonna(matrice, colonna) << "\n";
        }
    }
}

int schermoMenu() {
    int scelta;
    cout << "\n";
    cout << "------------------------------------------ \n";
    cout << "       Gestione matrici quadrate \n";
    cout << "------------------------------------------ \n";
    cout << "  1. Leggi dati matrice \n";
    cout << "  2. Genera matrice triangolare inferiore \n";
    cout << "  3. Genera matrice diagonale \n";
    cout << "  4. Stampa dati matrice \n";
    cout << "  5. Calcola somma elementi \n";
    cout << "  6. Calcola somma diagonale \n";
    cout << "  7. Calcola somma riga \n";
    cout << "  8. Calcola somma colonna \n";
    cout << "\n";
    cout << "  0. Esci \n";
    cout << "\n";
    cout << "------------------------------------------ \n";
    cout << "Immetti scelta -> ";
    cin >> scelta;
    while (scelta < 0 || scelta > 8) {
        cout << "** Errore: scelta scorretta \n";
        cout << "Immetti scelta -> ";
        cin >> scelta;
    }
    return scelta;
}

int schermoLeggiIndice() {
    int valore;
    cout << "Immetti valore -> ";
    cin >> valore;
    while (valore < 0 || valore > N - 1) {
        cout << "** Errore: scelta scorretta \n";
        cout << "Immetti valore -> ";
        cin >> valore;
    }
    return valore;
}

void leggiMatrice(int matrice[N][N]) {
    cout << "Immetti gli elementi \n";
    cout << "---------------------\n";
    for (int i = 0; i < N; i++) {
        cout << "Riga n. " << i << endl;
        for (int j = 0; j < N; j++) {
            cout << "   Elemento (" << i << "," << j << "): ";
            cin >> matrice[i][j];
        }
    }
}

void generaMatriceTriangolare(int matrice[N][N], int valore) {
    for (int i = 0; i < N; i++) {
        for (int j = 0; j < N; j++) {
            if (i >= j) {
                matrice[i][j] = valore;
            } else {
                matrice[i][j] = 0;
            }
        }
    }
}

void generaMatriceDiagonale(int matrice[N][N], int valore) {
    for (int i = 0; i < N; i++) {
        for (int j = 0; j < N; j++) {
            if (i == j) {
                matrice[i][j] = valore;
            } else {
                matrice[i][j] = 0;
            }
        }
    }
}

void stampaMatrice(int matrice[N][N]) {
    cout << "Valori della matrice \n";
    cout << "---------------------\n";
    for (int i = 0; i < N; i++) {
        cout << "\t";
        for (int j = 0; j < N; j++) {
            cout << matrice[i][j] << "\t";
        }
        cout << endl;
    }
}

int sommaElementi(int matrice[N][N]) {
    int somma = 0;
    for (int i = 0; i < N; i++) {
        for (int j = 0; j < N; j++) {
            somma += matrice[i][j];
        }
    }
    return somma;
}

int sommaDiagonale(int matrice[N][N]) {
    int somma = 0;
    for (int i = 0; i < N; i++) {
        somma += matrice[i][i];
    }
    return somma;
}

int sommaRiga(int matrice[N][N], int riga) {
    int somma = 0;
    for (int j = 0; j < N; j++) {
        somma += matrice[riga][j];
    }
    return somma;
}

int sommaColonna(int matrice[N][N], int colonna) {
    int somma = 0;
    for (int i = 0; i < N; i++) {
        somma += matrice[i][colonna];
    }
    return somma;
}