#include <stdio.h>
#include <math.h>

// Procedura per l'acquisizione dei coefficienti
void leggiEquazione (float* a, float* b, float* c) {
    printf("Inserisci i coefficienti dell'equazione \n");
    scanf("%f", &(*a));  // oppure scanf("%d", a);
    scanf("%f", &(*b));  // oppure scanf("%d", b);
    scanf("%f", &(*c));  // oppure scanf("%d", c);
    return;
}

// Procedura per la stampa dei dati di un'equazione
void stampaRadici (float a, float b, float c, float x, float y) {
    printf("------------ Equazione --------------\n");
    printf("%fx2+%fx+%f=0\n", a, b, c);
    printf("Radici: x=%f, y=%f\n", x, y);
    printf("-------------------------------------\n");
    return;
}

// Funzione per il calcolo del discriminante
float discriminante (float a, float b, float c) {
    float d;
    d = b * b - 4 * a * c;
    return d;
}

// Funzione per il calcolo della prima radice reale
float primaRadice (float a, float b, float c) {
    float x;
    x = (-b + sqrt(discriminante(a, b, c))) / (2 * a);
    return x;
}

// Funzione per il calcolo della seconda radice reale
float secondaRadice (float a, float b, float c) {
    float y;
    y = (-b - sqrt(discriminante(a, b, c))) / (2 * a);
    return y;
}

// Programma principale
int main() {
    float a1, b1, c1;
    float a2, b2, c2;
    float x1, y1, x2, y2;
    leggiEquazione(&a1, &b1, &c1);
    leggiEquazione(&a2, &b2, &c2);
    if (discriminante(a1, b1, c1) >= 0 && discriminante(a2, b2, c2) >= 0) {
        x1 = primaRadice(a1, b1, c1);
        y1 = secondaRadice(a1, b1, c1);
        x2 = primaRadice(a2, b2, c2);
        y2 = secondaRadice(a2, b2, c2);
        stampaRadici(a1, b1, c1, x1, y1);
        stampaRadici(a2, b2, c2, x2, y2);
        if ((x1==x2) || (x1==y2) || (y1==x2) || (y1==y2)) {
            printf("Le due equazioni hanno radici comuni\n");
        } else {
            printf("Le due equazioni non hanno radici comuni\n");
        }
    } else {
        printf("Non tutte le radici sono reali \n");
    }
    return 0;
}