/*
   equazioni3Lib.h
   Una libreria per la soluzione di equazioni di II grado
   versione 3.0
*/

/*
--NOME
leggiDatiEquazione
--DESCRIZIONE
procedura per l'acquisizione dalla tastiera dei coefficienti
dell'equazione nella forma ax2+bx+c=0
--PARAMETRI
a, b, c: i coefficienti dell'equazione
*/
void leggiDatiEquazione (float &a, float &b, float &c);

/*
--NOME
stampaDatiEquazione
--DESCRIZIONE
procedura per la stampa sullo schermo dei dati
relativi all'equazione nella forma ax2+bx+c=0
--PARAMETRI
a, b, c: i coefficienti dell'equazione
*/
void stampaDatiEquazione (float a, float b, float c);

/*
--NOME
stampaRadici
--DESCRIZIONE
procedura per la stampa sullo schermo dei valori delle radici
reali dell'equazione
--PARAMETRI
x, y: le due radici reali
*/
void stampaRadici (float x, float y);

/*
--NOME
discriminante
--DESCRIZIONE
funzione per il calcolo del discriminante
--PARAMETRI
a, b, c: i coefficienti dell'equazione
--RISULTATO
il valore del discriminante b2-4ac
*/
float discriminante (float a, float b, float c);

/*
--NOME
primaRadice
--DESCRIZIONE
funzione per il calcolo della prima radice reale
--PARAMETRI
a, b, c: i coefficienti dell'equazione
--RISULTATO
il valore della prima radice reale
--NOTA
la funzione assume che l'equazione abbia radici reali
*/
float primaRadice (float a, float b, float c);

/*
--NOME
secondaRadice
--DESCRIZIONE
funzione per il calcolo della prima seconda reale
--PARAMETRI
a, b, c: i coefficienti dell'equazione
--RISULTATO
il valore della prima seconda reale
--NOTA
la funzione assume che l'equazione abbia radici reali
*/
float secondaRadice (float a, float b, float c);
