/*
   equazioni4Lib.h
   Una libreria per la soluzione di equazioni di II grado
   versione 4.0
*/

/*
--TIPO DI DATO
*/

struct equazione {
    float a, b, c;
};

struct radiciReali {
    float x, y;
};

/*
--NOME
leggiDatiEquazione
--DESCRIZIONE
procedura per l'acquisizione dalla tastiera dei coefficienti
dell'equazione nella forma ax2+bx+c=0
--PARAMETRI
e: una equazione di II grado
*/
void leggiDatiEquazione (equazione &e);

/*
--NOME
stampaDatiEquazione
--DESCRIZIONE
procedura per la stampa sullo schermo dei dati
relativi all'equazione nella forma ax2+bx+c=0
--PARAMETRI
e: una equazione di II grado
*/
void stampaDatiEquazione (equazione e);

/*
--NOME
stampaRadici
--DESCRIZIONE
procedura per la stampa sullo schermo dei valori delle radici
reali dell'equazione
--PARAMETRI
r: le radici reali
*/
void stampaRadici (radiciReali r);

/*
--NOME
discriminante
--DESCRIZIONE
funzione per il calcolo del discriminante
--PARAMETRI
e: un'equazione di II grado
--RISULTATO
il valore del discriminante b2-4ac
*/
float discriminante (equazione e);

/*
--NOME
calcolaRadiciReali
--DESCRIZIONE
funzione per il calcolo delle radici reali
--PARAMETRI
e: un'equazione di II grado
--RISULTATO
la coppia di radici reali
*/
radiciReali calcolaRadiciReali (equazione e);
