#include <iostream.h>

#include "listaDiReali1.h"

void schermoMenu(int &scelta);
void leggiNomeFile(string &nomeFile);
void visualizza (bool esito);
void cerca(lista l);
void leggiValore(float &elem);
void leggiPosizione(int &pos);
void elabora(lista l);
float calcolaMedia(lista l);
int contaNegativi(lista l);
int posizioneMax(lista l);
int posizioneMin(lista l);
void stampaRisultato(lista l, float media, int negative,
                              int posMax, int posMin);

void main() {
    lista l;
    int scelta, pos;
    bool continua, esito;
    float elem;
    string nomeFile;

    l.indicatore = 0;
    continua=true;
    while (continua) {
        schermoMenu (scelta);
        if (scelta == 0) {
            continua=false;
        } else if (scelta == 1) {
            leggi (l);
            cout << "\n--- Operazione completata ---\n\n";
        } else if (scelta == 2) {
            stampa (l);
            cout << "\n--- Operazione completata ---\n\n";
        } else if (scelta == 3) {
            leggiNomeFile(nomeFile);
            salvaSuDisco(l, nomeFile);
            cout << "\n--- Operazione completata ---\n\n";
        } else if (scelta == 4) {
            leggiNomeFile(nomeFile);
            carica(l, nomeFile);
            cout << "\n--- Operazione completata ---\n\n";
        } else if (scelta == 5) {
            cerca(l);
            cout << "\n--- Operazione completata ---\n\n";
        } else if (scelta == 6) {
            leggiValore(elem);
            aggiungiInCoda(l, elem, esito);
            visualizza(esito);
        } else if (scelta == 7) {
            leggiValore(elem);
            leggiPosizione(pos);
            if (posizioneEsistente(l, pos)) {
                aggiungiInPosizione (l, elem, pos, esito);
                visualizza(esito);
            } else {
                cout << "\nErrore. Posizione non esistente.\n";
                cout << "Operazione abortita.\n\n";
            }
        } else if (scelta == 8) {
            eliminaInCoda(l, esito);
            visualizza(esito);
        } else if (scelta == 9) {
            leggiPosizione(pos);
            if (posizioneEsistente(l, pos)) {
                eliminaInPosizione (l, pos, esito);
                visualizza(esito);
            } else {
                cout << "\nErrore. Posizione non esistente.\n";
                cout << "Operazione abortita.\n\n";
            }
        } else if (scelta == 10) {
            leggiPosizione(pos);
            if (posizioneEsistente(l, pos)) {
                leggiValore(elem);
                l.valori[pos]=elem;
                cout << "\n--- Operazione completata ---\n\n";
            } else {
                cout << "\nErrore. Posizione non esistente.\n";
                cout << "Operazione abortita.\n\n";
            }
        } else if (scelta == 11) {
            if (l.indicatore > 0) {
                elabora(l);
                cout << "\n--- Operazione completata ---\n\n";
            } else {
                cout << "\nErrore. Lista vuota.\n";
                cout << "Operazione abortita.\n\n";
            }
        }
    }
}

void schermoMenu (int &scelta) {
    cout <<  "----------------------------------" << endl;
    cout <<  "        Menu Principale           " << endl;
    cout <<  "----------------------------------" << endl;
    cout << endl;
    cout <<  " 1. Leggi le temperature dalla tastiera" << endl;
    cout <<  " 2. Stampa le temperature" << endl;
    cout <<  " 3. Salva le temperature in un file" << endl;
    cout <<  " 4. Carica le temperature da file" << endl;
    cout <<  " 5. Cerca una temperatura" << endl;
    cout <<  " 6. Aggiungi una temperatura in coda" << endl;
    cout <<  " 7. Aggiungi una temperatura in posizione i" << endl;
    cout <<  " 8. Elimina una temperatura in coda" << endl;
    cout <<  " 9. Elimina una temperatura in posizione i" << endl;
    cout <<  "10. Modifica una temperatura" << endl;
    cout <<  "11. Elabora le temperature" << endl;
    cout << endl;
    cout <<  " 0. Esci dal programma" << endl;
    cout << endl;
    cout <<  " Scelta --> ";
    cin >> scelta;
    while ((scelta < 0) || (scelta > 11)) {
        cout <<  "Scelta scorretta. Ripetere" << endl;
        cout <<  "Scelta --> " << endl;
        cin >> scelta;
    }
    return;
}

void leggiNomeFile(string &nomeFile){
    cout << "\nImmetti il nome del file: ";
    cin >> nomeFile;
    return;
}

void visualizza (bool esito) {
    if (esito)
        cout << "\n--- Operazione completata ---\n\n";
    else {
        cout << "\n--- Si e' verificato un errore. ---\n";
        cout << "---     Operazione Abortita      ---\n\n";
    }
    return;
}

void cerca(lista l){
    int temp;
    float elem;
    leggiValore(elem);
    temp = cercaPosizione (l, elem);
    if (temp != -1) {
        cout << endl;
        cout <<  "Elemento contenuto in posizione " << temp << endl;
    } else
        cout <<  "Elemento non contenuto nella lista\n";
    return;
}

void leggiValore(float &elem) {
    cout << "\nImmetti il valore: ";
    cin >> elem;
    return;
}

void leggiPosizione(int &pos) {
    cout << "\nImmetti la posizione: ";
    cin >> pos;
    return;
}

void elabora(lista temperature) {
    int posMax, posMin, negative;
    float media;
    media = calcolaMedia(temperature);
    negative = contaNegativi(temperature);
    posMax = posizioneMax(temperature);
    posMin = posizioneMin(temperature);
    stampaRisultato(temperature, media, negative, posMax, posMin);
    return;
}

float calcolaMedia(lista l){
    float somma, media;
    int i;
    somma = 0;
    for (i = 0; i < l.indicatore; i++) {
        somma += l.valori[i];
    }
    media = somma/l.indicatore;
    return media;
}

int contaNegativi(lista l){
    int conta;
    int i;
    conta = 0;
    for (i = 0; i < l.indicatore; i++) {
        if(l.valori[i] < 0) {
            conta++;
        }
    }
    return conta;
}

int posizioneMax(lista l){
    int pos;
    int i;
    pos = 0;
    for (i = 1; i < l.indicatore; i++) {
        if (l.valori[i] > l.valori[pos]) {
            pos = i;
        }
    }
    return pos;
}

int posizioneMin(lista l){
    int pos;
    int i;
    pos=0;
    for (i = 1; i < l.indicatore; i++) {
        if (l.valori[i] < l.valori[pos]) {
            pos = i;
        }
    }
    return pos;
}

void stampaRisultato(lista temperature, float media, int negative,
                                           int posMax, int posMin){
    cout << "\n------------------------------\n";
    cout << "Temperature negative: " << negative << endl;
    cout << "Temperatura media complessiva: " << media << " gradi" << endl;
    cout << "Temperatura massima: " << temperature.valori[posMax] << " gradi" << endl;
    cout << "Temperatura minima: " << temperature.valori[posMin] << " gradi" << endl;
    cout << "\n------------------------------\n";
    return;
}