#include <iostream.h>

#include "listaDiReali2.h"
//#include "listaPtr1.h"
//#include "listaPtr2.h"
//#include "listaPtr3.h"

/*
   gestioneListe.cpp

   Programma per la gestione di liste di numeri reali

   Il programma utilizza la libreria di sottoprogrammi
   "listaDiReali.cpp" << endl;

   Viene presentato all"utente un menu per effettuare
   operazioni su insiemi di numeri reali
*/

void stampaMenu(int &scelta);

void main() {
    lista l;
    int scelta, pos, temp;
    bool continua, esito;
    float elem;
    string nomeFile;

    continua=true;
    while (continua) {
        stampaMenu (scelta);
        if (scelta==0) {
             continua=false;
        } else if (scelta==1) {
             leggi (l);
        } else if (scelta==2) {
             stampa (l);
        } else if (scelta==3) {
             cout << "\nImmetti il nome del file: ";
             cin >> nomeFile;
             salvaSuDisco(l, nomeFile);
        } else if (scelta==4) {
             cout << "\nImmetti il nome del file: ";
             cin >> nomeFile;
             carica(l, nomeFile);
        } else if (scelta==5) {
             cout << "\nNumero di elementi: " << numeroElementi(l) << endl;
        } else if (scelta==6) {
             if (listaVuota(l))
                 cout << "\nLa lista e' vuota. Non esistono elementi\n";
             else {
                 cout << "\nNumero di elementi attuale: " << numeroElementi(l) << endl;
                 cout << "Immetti la posizione: ";
                 cin >> pos;
                 while (pos < 0 || pos > numeroElementi(l) - 1) {
                     cout << "Errore. Posizione non ammessa. Riprovare\n";
                     cout << "Immetti la posizione: ";
                     cin >> pos;
                 }
                 cout << "\nElemento in posizione " << pos << ": " << elementoInPosizione(l, pos) << endl;
             }
        } else if (scelta==7) {
             cout <<  "\nImmetti il valore da cercare: ";
             cin >> elem;
             temp = cercaPosizione (l, elem);
             if (temp != -1) {
                 cout << endl;
                 cout <<  "Elemento contenuto in posizione " << temp << endl;
             } else
                 cout <<  "Elemento non contenuto nella lista\n";
        } else if (scelta==8) {
             cout << "\nImmetti il valore da aggiungere: ";
             cin >> elem;
             aggiungi (l, elem, esito);
             if (!esito) {
                 cout << "\n--- Si e' verificato un errore. ---\n";
                 cout << "---     Operazione Abortita      ---\n\n";
             }
        } else if (scelta==9) {
             cout <<  "\nImmetti il valore da aggiungere: ";
             cin >> elem;
             cout <<  "Immetti la posizione: ";
             cin >> pos;
             aggiungi (l, elem, pos, esito);
             if (!esito) {
                 cout <<  "\n--- Si e' verificato un errore. ---\n";
                 cout <<  "---     Operazione Abortita      ---\n";
             }
        } else if (scelta==10) {
             elimina (l, esito);
             if (!esito) {
                 cout <<  "\n--- Si e' verificato un errore.\n";
                 cout <<  "---     Operazione Abortita      ---\n\n";
             }
        } else if (scelta==11) {
             cout <<  "\nImmetti la posizione dell'elemento: ";
             cin >> pos;
             elimina (l, pos, esito);
             if (!esito) {
                 cout <<  "\n--- Si e' verificato un errore.\n";
                 cout <<  "---     Operazione Abortita      ---\n\n";
             }
        }
    }
}

void stampaMenu (int &scelta) {
      cout << "\n";
      cout <<  "----------------------------------" << endl;
      cout <<  "        Menu Principale           " << endl;
      cout <<  "----------------------------------" << endl;
      cout << endl;
      cout <<  " 1. Leggi la Lista dalla Tastiera" << endl;
      cout <<  " 2. Stampa la Lista" << endl;
      cout <<  " 3. Salva la Lista in un File" << endl;
      cout <<  " 4. Carica la Lista da File" << endl;
      cout <<  " 5. Stampa Numero Elementi" << endl;
      cout <<  " 6. Stampa Elemento in Posizione i" << endl;
      cout <<  " 7. Cerca un elemento" << endl;
      cout <<  " 8. Aggiungi un Elemento in Coda" << endl;
      cout <<  " 9. Aggiungi un Elemento in Posizione i" << endl;
      cout <<  "10. Elimina un Elemento in Coda" << endl;
      cout <<  "11. Elimina un Elemento in Posizione" << endl;
      cout << endl;
      cout <<  " 0. Esci dal programma" << endl;
      cout << endl;
      cout <<  " Scelta --> ";
      cin >> scelta;
      while ((scelta < 0) || (scelta > 11)) {
          cout <<  "Scelta scorretta. Ripetere" << endl;
          cout <<  "Scelta --> " << endl;
          cin >> scelta;
      }
      return;
}

