#include <iostream.h>
#include <fstream.h>
#include "listaDiReali1.h"

/*
  listaDiReali1.cpp
  ------------------
  libreria per la gestione di liste di numeri reali rappresentate
  con array e indicatore di riempimento

  Nota: la libreria e' stata scritta esclusivamente a scopo didattico
  http://www.difa.unibas.it/users/gmecca/corsi/informatica
*/

//---------------------------

  void leggi (lista &l) {
      int i;
      cout << "\nLettura dei valori della lista" << endl;
      cout << "------------------------------" << endl;
      cout << endl;
      leggiIndicatore(l.indicatore);
      for (i = 0; i < l.indicatore; i++) {
          cout << "--Immetti il valore in posizione " << i << ": ";
          cin >> l.valori[i];
      }
      return;
  }

  void leggiIndicatore (int &indicatore) {
      cout << "Quanti valori contiene la lista ? ";
      cin >> indicatore;
      while (indicatore < 0 || indicatore > MAXDIM) {
          cout << "ERRORE: VALORE NON AMMESSO" << endl;
          cout << "Il valore deve essere compreso tra 0 e " << MAXDIM << endl;
          cout << "Immetti valore corretto: ";
          cin >> indicatore;
      }
      return;
  }

  void stampa (lista l) {
      int i;
      cout << "\nStampa dei valori della lista" << endl;
      cout << "-----------------------------" << endl;
      if (l.indicatore == 0) {
          cout << "Lista vuota" << endl;
      } else {
          for (i = 0; i < l.indicatore; i++) {
              cout << "--Valore in posizione " <<  i  << ": " << l.valori[i] << endl;
          }
      }
      return;
  }

  void salvaSuDisco (lista l, string nomeFile) {
      int i;
      ofstream outFile(nomeFile.c_str());
      for (i = 0; i < l.indicatore; i++) {
          outFile << l.valori[i]  << endl;
      }
      outFile.close();
      return;
  }

  void carica (lista &l, string nomeFile){
      int i;
      ifstream inFile(nomeFile.c_str());
      i = 0;
      while (inFile >> l.valori[i] && i<MAXDIM){
          i++;
      }
      l.indicatore = i;
      inFile.close();
      return;
  }

  void aggiungiInCoda (lista &l, float elem, bool &esito){
      if (l.indicatore == MAXDIM) {
          esito = false;
      } else {
          l.valori[l.indicatore] = elem;
          l.indicatore++;
          esito = true;
      }
      return;
  }

  void aggiungiInPosizione (lista &l, float elem, int pos, bool &esito) {
      int i;
      if (l.indicatore == MAXDIM || (!posizioneEsistente(l,pos) && pos != l.indicatore)) {
          esito=false;
      } else {
          i = l.indicatore-1;
          while (i >= pos) {
              l.valori[i+1] = l.valori[i];
              i--;
          }
          l.valori[pos] = elem;
          l.indicatore++;
          esito = true;
      }
      return;
  }

  void eliminaInCoda (lista &l, bool& esito){
      int i;
      if (l.indicatore == 0) {
          esito = false;
      } else {
          l.indicatore--;
          esito = true;
      }
      return;
  }

  void eliminaInPosizione (lista &l, int pos, bool& esito){
      int i;
      if (!posizioneEsistente(l,pos)) {
          esito = false;
      } else {
          for (i = pos; i < l.indicatore - 1; i++) {
              l.valori[i] = l.valori[i+1];
          }
          l.indicatore--;
          esito = true;
      }
      return;
  }

  int cercaPosizione (lista l, float elem) {
      int i;
      bool trovato = false;
      int risultato = -1;
      i = 0;
      while ((i < l.indicatore) && (!trovato)) {
          if (l.valori[i] == elem){
              trovato = true;
              risultato=i;
          } else {
              i++;
          }
      }
      return risultato;
  }

  bool posizioneEsistente (lista l, int pos){
      bool esiste;
      if (l.indicatore == 0) {
          esiste=false;
      } else {
          esiste = (pos >= 0 && pos < l.indicatore);
      }
      return esiste;
  }
