/*
  listaDiReali1.h
  ----------------
  file delle intestazioni di una libreria per la gestione di liste
  di numeri reali rappresentate con array e indicatore di riempimento

  Nota: la libreria e' stata scritta esclusivamente a scopo didattico
  http://www.difa.unibas.it/users/gmecca/corsi/informatica
*/

//COSTANTI GLOBALI:
//-----------------
  const int MAXDIM=10000;
  //--> dimensione massima dell'insieme di numeri reali

//MODELLO DI STRUTTURA
  struct lista {
      int indicatore;
      float valori[MAXDIM];
  };

//PROCEDURE:
//----------
  void leggi (lista &l);
  //--> effettua la lettura dei valori della lista l dalla tastiera
  //lista &l --> la lista

  void stampa (lista l);
  //--> effettua la stampa dei valori della lista l sullo schermo
  //lista l --> la lista

  void salvaSuDisco (lista l, string nomeFile);
  //--> salva i valori della lista l in un file
  //lista l --> la lista
  //string nomeFile --> il nome del file

  void carica (lista &l, string nomeFile);
  //--> carica i valori della lista l da un file
  //lista &l --> la lista
  //string nomeFile --> il nome del file

  void aggiungiInCoda (lista &l, float elem, bool& esito);
  //--> aggiunge "elem" in coda ai valori della lista l se
  //    questo e' possibile; "esito" segnala la riuscita
  //    dell'operazione
  //lista &l --> la lista
  //float elem    --> elemento da aggiungere
  //bool esito--> segnala l'esito dell'operazione

  void aggiungiInPosizione (lista &l, float elem, int pos, bool& esito);
  //--> aggiunge "elem" ai valori della lista l in posizione pos se
  //    questo e' possibile; "esito" segnala la riuscita
  //    dell'operazione
  //lista &l --> la lista
  //float elem    --> elemento da aggiungere
  //int pos  --> posizione in cui aggiungere
  //bool esito--> segnala l'esito dell'operazione

  void eliminaInCoda (lista &l, bool& esito);
  //--> elimina l'ultimo elemento dalla lista l se
  //    questo e' possibile; "esito" segnala la riuscita
  //  dell'operazione
  //lista &l --> la lista
  //bool esito--> segnala l'esito dell'operazione

  void eliminaInPosizione (lista &l, int pos, bool& esito);
  //--> elimina un elemento in posizione "pos" dalla lista l se
  //    questo e' possibile; "esito" segnala la riuscita
  //  dell'operazione
  //lista &l --> la lista
  //int pos  --> posizione in cui aggiungere
  //bool esito--> segnala l'esito dell'operazione

  void leggiIndicatore (int &indicatore);
  //--> legge dalla tastiera il numero di elementi della lista
  //int &indicatore  --> indicatore di riempimento della lista

//FUNZIONI:
//---------

  int cercaPosizione (lista l, float elem);
  //--> se "elem" e' contenuto nella lista l ne restituisce
  //    la posizione; -1 altrimenti; nel caso l'insieme
  //    "ins" contenga piu' occorrenze di "elem", viene
  //    restituita la posizione della prima occorrenza
  //lista l --> la lista
  //float elem    --> elemento da cercare

  bool posizioneEsistente (lista l, int pos);
  //--> verifica che pos sia una posizione esistente nella lista
  //int pos --> la posizione da verificare
