C  listaDiReali1f.for
C  ------------------
C  una libreria per la gestione di liste 
C  di numeri reali con indicatore di riempimento
C
C  Nota: la libreria e' stata scritta
C  esclusivamente a scopo didattico
C  http://www.ing.unibas.it/corsi/informatica
C
C  PROCEDURE:
C  ---------
C  subroutine leggiIndic (ind) 
C  --> effettua la lettura dell'indicatore di riempimento
C      della lista
C  integer ind  --> indicatore di riempimento
C
C  subroutine leggi (dati, ind) 
C  --> effettua la lettura della lista dalla tastiera
C  real dati(100) --> lista di numeri reali
C  integer ind  --> indicatore di riempimento
C
C  subroutine stampa (dati, ind) 
C  --> stampa i dati della lista sullo schermo
C  real dati(100) --> lista di numeri reali
C  integer ind  --> indicatore di riempimento
C
C  subroutine salva (dati, ind, nomeFile, esito)
C  --> salva gli elementi della lista nel file
C      di nome "nomeFile"; "esito" segnala la riuscita
C      dell'operazione
C  real dati(100) --> lista di numeri reali
C  integer ind  --> indicatore di riempimento
C  character*60 nomeFile --> un nome di file fisico
C  logical esito--> segnala l'esito dell'operazione
C
C  subroutine carica (dati, ind, nomeFile, esito)
C  --> carica gli elementi della lista dal file
C      di nome "nomeFile"; "esito" segnala la riuscita
C      dell'operazione
C  real dati(100) --> lista di numeri reali
C  integer ind  --> indicatore di riempimento
C  character*60 nomeFile --> un nome di file fisico
C  logical esito--> segnala l'esito dell'operazione
C
C  subroutine aggInCoda (dati, ind, elem, esito)
C  --> aggiunge "elem" in coda alla lista se
C      questo e' possibile; "esito" segnala la riuscita
C      dell'operazione
C  real dati(100) --> lista di numeri reali
C  integer ind  --> indicatore di riempimento
C  real elem    --> elemento da aggiungere
C  logical esito--> segnala l'esito dell'operazione
C
C  subroutine aggInPos (dati, ind, elem, pos, esito)
C  --> aggiunge "elem" alla lista in posizione "pos" se
C      questo e' possibile; "esito" segnala la riuscita
C      dell'operazione
C  real dati(100) --> lista di numeri reali
C  integer ind  --> indicatore di riempimento
C  real elem    --> elemento da aggiungere
C  integer pos  --> posizione in cui aggiungere
C  logical esito--> segnala l'esito dell'operazione
C
C  subroutine elInPos (dati, ind, pos, esito)
C  --> elimina un elemento in posizione "pos" dalla lista se
C      questo e' possibile; "esito" segnala la riuscita
C      dell'operazione
C  real dati(100) --> lista di numeri reali
C  integer ind  --> indicatore di riempimento
C  integer pos  --> posizione in cui aggiungere
C  logical esito--> segnala l'esito dell'operazione
C
C  FUNZIONI:
C  ---------
C  integer function cercaPos (dati, ind, elem)
C  --> se "elem" e' contenuto nella lista ne restituisce
C      la posizione; 0 altrimenti; nel caso la lista
C      contenga piu' occorrenze di "elem", viene
C      restituita la posizione della prima occorrenza
C  real dati(100) --> lista di numeri reali
C  integer ind  --> indicatore di riempimento
C  real elem    --> elemento da cercare
C
C-------------------------------------------------------

      subroutine leggiIndic (ind)
      implicit none
      integer ind
      write (*,*) 'Quanti elementi contiene la lista ?'
      read  (*,*) ind
      do while ((ind.lt.0).or.(ind.gt.100))
         write (*,*) 'ERRORE: Numero scorretto'
         write (*,*) 'Inserisci valore corretto (tra 0 e 100)'
         read (*,*) ind
      end do
      return
      end


      subroutine leggi (dati, ind)
      implicit none
      real dati(100)
      integer ind
10    format (1X,A20,I3)
      integer i
      call leggiIndic(ind)
      do i=1,ind
          write (*,10) '--Immetti il valore n.', i
          read (*,*) dati(i)
      end do
      return
      end


      subroutine stampa (dati, ind)
      implicit none
      real dati(100)
      integer ind
22    format (1X,A12,I3,A2,F8.2)
      integer i
      if (ind.eq.0) then
          write (*,*) 'Lista vuota'
      else
          do i=1,ind
              write (*,22) '--Elemento n.', i, ':', dati(i)
          end do
      endif
      return
      end


      subroutine salva (dati, ind, nomeFile, esito)
      implicit none
      real dati(100)
      integer ind
      character*60 nomeFile
      logical esito
32    format (I3)
31    format (F8.2)
      integer i
      open (unit=9, file=nomeFile, err=33)           
      write (9, 32) ind      
      do i=1, ind
          write (9, 31) dati(i)
      end do
      endfile (9)
      close (9)
      esito=.true.
      return
C-----In caso di errore
33    esito=.false.
      return
      end
      

      subroutine carica (dati, ind, nomeFile, esito)
      implicit none 
      real dati(100)
      integer ind
      character*60 nomeFile
      logical esito
42    format (I3)
41    format (F8.2)
      integer i
      open (UNIT=9, FILE=nomeFile, err=44)           
      read (9,42) ind     
      do i=1, ind
          read (9, 41, err=44) dati(i)
      end do
      close (9)
      esito=.true.
      return
C-----In caso di errore
44    esito=.false.
      ind=0
      return
      end
      

      subroutine aggInCoda (dati, ind, elem, esito)
      implicit none
      real dati(100)
      integer ind
      real elem
      logical esito
      if (ind.eq.100) then
          esito=.false.
      else
          dati(ind+1) = elem
          ind=ind+1
          esito = .true.
      endif
      return
      end
            

      subroutine aggInPos (dati, ind, elem, pos, esito)
      implicit none
      real dati(100)
      integer ind
      real elem
      integer pos
      logical esito   
      integer i
      if ((ind.eq.100).or.(pos.gt.ind)) then
          esito=.false.
      else
          i=ind
          do while(i.ge.pos)
              dati(i+1) = dati(i)
              i=i-1
          enddo
          dati(pos)=elem
          ind=ind+1
          esito = .true.
      endif
      return
      end


      subroutine elInPos (dati, ind, pos, esito)
      implicit none
      real dati(100)
      integer ind
      integer pos
      logical esito      
      integer i
      if ((ind.eq.0).or.(pos.gt.ind)) then
          esito=.false.
      else
          do i=pos,ind-1
              dati(i) = dati(i+1)
          end do
          ind=ind-1
          esito = .true.
      endif
      return
      end
            

      integer function cercaPos (dati, ind, elem)
      implicit none
      real dati(100)
      integer ind
      real elem
      logical trovato
      integer i
      trovato=.false.
      i=1
      do while ((i.le.ind).and.(.not.trovato))
          if (dati(i).eq.elem) then
              trovato=.true.
          else
              i=i+1
          endif
      enddo
      if (trovato) then
          cercaPos = i
      else
          cercaPos = 0
      endif
      return
      end