#include <iostream.h>
#include <fstream.h>
#include "listaDiReali2.h"

/*
  listaDiReali.cpp
  ------------------
  libreria per la gestione di liste di numeri reali rappresentate
  con array e indicatore di riempimento

  Nota: la libreria e' stata scritta esclusivamente a scopo didattico
  http://www.difa.unibas.it/users/gmecca/corsi/informatica
*/

// SOTTOPROGRAMMI DI SERVIZIO:
//---------------------------
  void leggiIndicatore (int &indicatore);
  //--> legge dalla tastiera il numero di elementi della lista
  //int &indicatore  --> indicatore di riempimento della lista

  bool posizioneEsistente (lista l, int pos);
  //--> verifica che pos sia una posizione esistente nella lista
  //int pos --> la posizione da verificare

//---------------------------

  void inizializza (lista &l) {
      l.indicatore = 0;
      return;
  }

  void leggi (lista &l) {
      int i;
      cout << "\nLettura dei valori della lista" << endl;
      cout << "------------------------------" << endl;
      cout << endl;
      leggiIndicatore(l.indicatore);
      for (i = 0; i < l.indicatore; i++) {
          cout << "--Immetti il valore n." << i << ": ";
          cin >> l.valori[i];
      }
      return;
  }

  void stampa (lista l) {
      int i;
      cout << "\nStampa dei valori della lista" << endl;
      cout << "-----------------------------" << endl;
      if (listaVuota(l)) {
          cout << "Lista vuota" << endl;
      } else {
          for (i=0;i<l.indicatore;i++) {
              cout << "--Valore n." <<  i  << ": " << l.valori[i] << endl;
          }
      }
      return;
  }

  void salvaSuDisco (lista l, string nomeFile) {
      int i;
      ofstream outFile(nomeFile.c_str());
      for (i = 0; i < l.indicatore; i++) {
          outFile << l.valori[i]  << endl;
      }
      outFile.close();
      return;
  }

  void carica (lista &l, string nomeFile){
      int i;
      ifstream inFile(nomeFile.c_str());
      inizializza(l);
      while (inFile >> l.valori[l.indicatore]) {
          l.indicatore++;
      }
      inFile.close();
      return;
  }

  void aggiungi (lista &l, tipoValori elem, bool& esito){
      if (listaPiena(l)) {
          esito = false;
      } else {
          l.valori[l.indicatore] = elem;
          l.indicatore++;
          esito = true;
      }
      return;
  }

  void aggiungi (lista &l, tipoValori elem, int pos, bool& esito) {
      int i;
      if (listaPiena(l)) {
          esito = false;
      } else if (!posizioneEsistente(l,pos) && pos != numeroElementi(l)) {
          esito = false;
      } else {
          i = l.indicatore-1;
          while (i>=pos) {
              l.valori[i+1] = l.valori[i];
              i--;
          }
          l.valori[pos] = elem;
          l.indicatore = l.indicatore + 1;
          esito = true;
      }
      return;
  }

  void elimina (lista &l, bool& esito){
      int i;
      if (listaVuota(l)) {
          esito = false;
      } else {
          l.indicatore--;
          esito = true;
      }
      return;
  }

  void elimina (lista &l, int pos, bool& esito){
      int i;
      if (!posizioneEsistente(l,pos)) {
          esito = false;
      } else {
          for (i = pos; i < l.indicatore - 1; i++) {
              l.valori[i] = l.valori[i+1];
          }
          l.indicatore--;
          esito = true;
      }
      return;
  }

  int cercaPosizione (lista l, tipoValori elem) {
      int i;
      for (i = 0; i < l.indicatore; i++) {
          if (l.valori[i] == elem) {
              return i;
          }
      }
      return -1;
  }

  int numeroElementi (lista l){
      return (l.indicatore);
  }

  float elementoInPosizione (lista l, int pos){
      if (!posizioneEsistente(l, pos)) {
          cout << "\n--- Errore ---\n";
          exit(1);
      }
      return (l.valori[pos]);
  }

  bool listaVuota (lista l) {
      return (l.indicatore == 0);
  }

  bool listaPiena (lista l) {
      return (l.indicatore == MAXDIM);
  }

// SOTTOPROGRAMMI DI SERVIZIO

  void leggiIndicatore (int &indicatore) {
      cout << "Quanti valori contiene la lista ? ";
      cin >> indicatore;
      while (indicatore < 0 || indicatore > MAXDIM) {
          cout << "ERRORE: VALORE NON AMMESSO" << endl;
          cout << "Il valore deve essere compreso tra 0 e " << MAXDIM << endl;
          cout << "Immetti valore corretto: ";
          cin >> indicatore;
      }
      return;
  }

  bool posizioneEsistente (lista l, int pos){
      bool esiste;
      if (listaVuota(l)) {
          esiste = false;
      } else {
          esiste = (pos >= 0 && pos < l.indicatore);
      }
      return esiste;
  }
