#include "listaPtr1.cpp"
//#include "listaPtr2.cpp"
//#include "listaPtr3.cpp"
//#include "listaPtr4.cpp"

void assert(string s, bool p) {
    if (!p) {
        cout << "\n  **** Errore: " << s << endl;
        //exit(1);
    } else {
        cout << ".";
    }
    return;
}

void testInizializza() {
    cout << "\ntestInizializza" << endl;
    lista l;
    inizializza(l);
    assert("Lista vuota", listaVuota(l));
    assert("Numero elementi", numeroElementi(l) == 0);
    return;
}

void testListaPiena() {
    cout << "\ntestListaPiena" << endl;
    bool esito;
    lista l;
    inizializza(l);
    assert("Lista non piena 1", !listaPiena(l));
    aggiungiInTesta(l, 1, esito);
    aggiungiInTesta(l, 2, esito);
    assert("Lista non piena 2", !listaPiena(l));
    return;
}

void testAggiungiInTesta1() {
    cout << "\ntestAggiungiInTesta1 - un elemento" << endl;
    lista l;
    bool esito;
    inizializza(l);
    aggiungiInTesta(l, 10, esito);
    assert("Inserimento effettuato", esito);
    assert("Lista non vuota", !listaVuota(l));
    assert("Numero elementi", numeroElementi(l) == 1);
    assert("Primo elemento", elementoInPosizione(l, 0) == 10);
    assert("Ricerca", cercaPosizione(l, 10) == 0);
    return;
}

void testAggiungiInTesta2() {
    cout << "\ntestAggiungiInTesta2- due elementi" << endl;
    lista l;
    bool esito;
    inizializza(l);
    aggiungiInTesta(l, 10, esito);
    assert("Inserimento effettuato", esito);
    assert("Lista non vuota", !listaVuota(l));
    assert("Numero elementi", numeroElementi(l) == 1);
    aggiungiInTesta(l, 20, esito);
    assert("Inserimento effettuato", esito);
    assert("Lista non vuota", !listaVuota(l));
    assert("Numero elementi", numeroElementi(l) == 2);
    assert("Primo elemento", elementoInPosizione(l, 0) == 20);
    assert("Ricerca 20", cercaPosizione(l, 20) == 0);
    assert("Secondo elemento", elementoInPosizione(l, 1) == 10);
    assert("Ricerca 10", cercaPosizione(l, 10) == 1);
    assert("Ricerca 0", cercaPosizione(l, 0) == -1);
    return;
}

void testPuntatoreAllUltimo1() {
    cout << "\ntestPuntatoreAllUltimo - lista vuota" << endl;
    lista l;
    bool esito;
    inizializza(l);
    elemento* p;
    p = puntatoreAllUltimo(l);
    assert("Lista vuota", p == NULL);
    return;
}

void testPuntatoreAllUltimo2() {
    cout << "\ntestPuntatoreAllUltimo - lista non vuota" << endl;
    lista l;
    bool esito;
    inizializza(l);
    elemento* p;
    aggiungiInTesta(l, 10, esito);
    p = puntatoreAllUltimo(l);
    assert("Un elemento", p != NULL);
    assert("Valore 10", p->valore == 10);
    aggiungiInTesta(l, 20, esito);
    p = puntatoreAllUltimo(l);
    assert("Due elementi", p != NULL);
    assert("Valore 10", p->valore == 10);
    aggiungiInTesta(l, 30, esito);
    assert("Numero elementi", numeroElementi(l) == 3);
    assert("Primo elemento", elementoInPosizione(l, 0) == 30);
    assert("Secondo elemento", elementoInPosizione(l, 1) == 20);
    assert("Terzo elemento", elementoInPosizione(l, 2) == 10);
    p = puntatoreAllUltimo(l);
    assert("Tre elementi", p != NULL);
    assert("Valore 10", p->valore == 10);
    return;
}

void testAggiungiInCoda1() {
    cout << "\ntestAggiungiInCoda - lista vuota" << endl;
    bool esito;
    lista l;
    inizializza(l);
    aggiungi(l, 10, esito);
    assert("Lista non vuota", !listaVuota(l));
    assert("Un elemento", numeroElementi(l) == 1);
    assert("Valore 10", elementoInPosizione(l, 0) == 10);
    return;
}

void testAggiungiInCoda2() {
    cout << "\ntestAggiungiInCoda2 - lista non vuota" << endl;
    bool esito;
    lista l;
    inizializza(l);
    aggiungiInTesta(l, 10, esito);
    assert("Lista non vuota", !listaVuota(l));
    assert("Un elemento", numeroElementi(l) == 1);
    assert("Valore 10", elementoInPosizione(l, 0) == 10);
    aggiungi(l, 20, esito);
    assert("Lista non vuota", !listaVuota(l));
    assert("Due elementi", numeroElementi(l) == 2);
    assert("Valore 20", elementoInPosizione(l, 1) == 20);
    aggiungi(l, 30, esito);
    assert("Lista non vuota", !listaVuota(l));
    assert("Tre elementi", numeroElementi(l) == 3);
    assert("Valore 30", elementoInPosizione(l, 2) == 30);
    assert("Cerca 10", cercaPosizione(l, 10) == 0);
    assert("Cerca 20", cercaPosizione(l, 20) == 1);
    assert("Cerca 30", cercaPosizione(l, 30) == 2);
    assert("Cerca 0", cercaPosizione(l, 0) == -1);
    return;
}

void testAggiungiInPosizione1() {
    cout << "\ntestAggiungiInPosizione1 - posizioni corrette" << endl;
    bool esito;
    lista l;
    inizializza(l);
    aggiungi(l, 10, esito);
    aggiungi(l, 20, esito);
    aggiungi(l, 30, esito);
    aggiungi(l, 40, esito);
    assert("Quattro elementi", numeroElementi(l) == 4);
    assert("Valore 10", elementoInPosizione(l, 0) == 10);
    assert("Valore 20", elementoInPosizione(l, 1) == 20);
    assert("Valore 30", elementoInPosizione(l, 2) == 30);
    assert("Valore 40", elementoInPosizione(l, 3) == 40);
    assert("Cerca 0", cercaPosizione(l, 0) == -1);
    assert("Cerca 1", cercaPosizione(l, 1) == -1);
    aggiungi(l, 0, 1, esito);
    assert("Cinque elementi", numeroElementi(l) == 5);
    assert("Cerca 0", cercaPosizione(l, 0) == 1);
    assert("Valore 10", elementoInPosizione(l, 0) == 10);
    assert("Valore 0", elementoInPosizione(l, 1) == 0);
    assert("Valore 20", elementoInPosizione(l, 2) == 20);
    assert("Valore 30", elementoInPosizione(l, 3) == 30);
    assert("Valore 40", elementoInPosizione(l, 4) == 40);
    aggiungi(l, 1, 3, esito);
    assert("Sei elementi", numeroElementi(l) == 6);
    assert("Cerca 1", cercaPosizione(l, 1) == 3);
    assert("Valore 10", elementoInPosizione(l, 0) == 10);
    assert("Valore 0", elementoInPosizione(l, 1) == 0);
    assert("Valore 20", elementoInPosizione(l, 2) == 20);
    assert("Valore 1", elementoInPosizione(l, 3) == 1);
    assert("Valore 30", elementoInPosizione(l, 4) == 30);
    assert("Valore 40", elementoInPosizione(l, 5) == 40);
    return;
}

void testAggiungiInPosizione2() {
    cout << "\ntestAggiungiInPosizione2 - posizioni scorrette" << endl;
    bool esito;
    lista l;
    inizializza(l);
    aggiungi(l, 20, esito);
    aggiungi(l, 10, esito);
    aggiungi(l, 30, esito);
    aggiungi(l, 40, esito);
    assert("Lista non vuota", !listaVuota(l));
    assert("Quattro elementi", numeroElementi(l) == 4);
    assert("Esito", esito);
    aggiungi(l, 0, 10, esito);
    assert("Ins. Fallito", !esito);
    aggiungi(l, 0, -1, esito);
    assert("Ins. Fallito", !esito);
    aggiungi(l, 0, 4, esito);
    assert("Ins. Riuscito", esito);
    aggiungi(l, 0, 3, esito);
    assert("Ins. Riuscito", esito);
    assert("Sei elementi", numeroElementi(l) == 6);
    return;
}

void testAggiungiInPosizione3() {
    cout << "\ntestAggiungiInPosizione3 - lista vuota" << endl;
    bool esito;
    lista l;
    inizializza(l);
    aggiungi(l, 20, 0, esito);
    assert("Ins. riuscito", esito);
    assert("Lista non vuota", !listaVuota(l));
    assert("Un elemento", numeroElementi(l) == 1);
    assert("Valore 20", elementoInPosizione(l, 0) == 20);
    aggiungi(l, 10, 0, esito);
    assert("Ins. Riuscito", esito);
    assert("Due elementi", numeroElementi(l) == 2);
    assert("Valore 10", elementoInPosizione(l, 0) == 10);
    return;
}

void testEliminaInCoda1() {
    cout << "\ntestEliminaInCoda1 - posizioni corrette" << endl;
    bool esito;
    lista l;
    inizializza(l);
    elimina(l, esito);
    assert("Elim. fallita", !esito);
    aggiungi(l, 10, 0, esito);
    aggiungi(l, 20, esito);
    aggiungi(l, 30, esito);
    aggiungi(l, 40, esito);
    assert("Quattro elementi", numeroElementi(l) == 4);
    assert("Valore 10", elementoInPosizione(l, 0) == 10);
    assert("Valore 20", elementoInPosizione(l, 1) == 20);
    assert("Valore 30", elementoInPosizione(l, 2) == 30);
    assert("Valore 40", elementoInPosizione(l, 3) == 40);
    elimina(l, esito);
    assert("Elim. riuscita", esito);
    assert("Tre elementi", numeroElementi(l) == 3);
    assert("Cerca 40", cercaPosizione(l, 40) == -1);
    assert("Valore 10", elementoInPosizione(l, 0) == 10);
    assert("Valore 20", elementoInPosizione(l, 1) == 20);
    assert("Valore 30", elementoInPosizione(l, 2) == 30);
    elimina(l, esito);
    assert("Elim. riuscita", esito);
    assert("Due elementi", numeroElementi(l) == 2);
    assert("Cerca 30", cercaPosizione(l, 30) == -1);
    assert("Valore 10", elementoInPosizione(l, 0) == 10);
    assert("Valore 20", elementoInPosizione(l, 1) == 20);
    return;
}

void testEliminaInCoda2() {
    cout << "\ntestEliminaInCoda2 - posizioni scorrette" << endl;
    bool esito;
    lista l;
    inizializza(l);
    elimina(l, esito);
    assert("Elim. fallita", !esito);
    aggiungi(l, 20, esito);
    aggiungi(l, 10, 0, esito);
    assert("Due elementi", numeroElementi(l) == 2);
    elimina(l, esito);
    assert("Elim. riuscita", esito);
    assert("Un elemento", numeroElementi(l) == 1);
    assert("Cerca 20", cercaPosizione(l, 20) == -1);
    assert("Valore 10", elementoInPosizione(l, 0) == 10);
    elimina(l, esito);
    assert("Elim. riuscita", esito);
    assert("Lista vuota", listaVuota(l));
    return;
}

void testEliminaInCoda3() {
    cout << "\ntestEliminaInCoda3 - lista vuota" << endl;
    bool esito;
    lista l;
    inizializza(l);
    elimina(l, esito);
    assert("Elim. fallita", !esito);
    aggiungi(l, 10, esito);
    assert("Un elemento", numeroElementi(l) == 1);
    elimina(l, esito);
    assert("Elim. riuscita", esito);
    assert("Lista vuota", listaVuota(l));
    elimina(l, esito);
    assert("Elim. fallita", !esito);
    return;
}

void testEliminaInPosizione1() {
    cout << "\ntestEliminaInPosizione1 - posizioni corrette" << endl;
    bool esito;
    lista l;
    inizializza(l);
    aggiungi(l, 10, esito);
    aggiungi(l, 20, esito);
    aggiungi(l, 30, esito);
    aggiungi(l, 40, esito);
    assert("Quattro elementi", numeroElementi(l) == 4);
    assert("Valore 10", elementoInPosizione(l, 0) == 10);
    assert("Valore 20", elementoInPosizione(l, 1) == 20);
    assert("Valore 30", elementoInPosizione(l, 2) == 30);
    assert("Valore 40", elementoInPosizione(l, 3) == 40);
    elimina(l, 2, esito);
    assert("Elim. riuscita", esito);
    assert("Tre elementi", numeroElementi(l) == 3);
    assert("Cerca 30", cercaPosizione(l, 30) == -1);
    assert("Valore 10", elementoInPosizione(l, 0) == 10);
    assert("Valore 20", elementoInPosizione(l, 1) == 20);
    assert("Valore 40", elementoInPosizione(l, 2) == 40);
    elimina(l, 0, esito);
    assert("Elim. riuscita", esito);
    assert("Due elementi", numeroElementi(l) == 2);
    assert("Cerca 10", cercaPosizione(l, 10) == -1);
    assert("Valore 20", elementoInPosizione(l, 0) == 20);
    assert("Valore 40", elementoInPosizione(l, 1) == 40);
    return;
}

void testEliminaInPosizione2() {
    cout << "\ntestEliminaInPosizione2 - posizioni scorrette" << endl;
    bool esito;
    lista l;
    inizializza(l);
    aggiungi(l, 10, esito);
    assert("Un elemento", numeroElementi(l) == 1);
    elimina(l, 2, esito);
    assert("Elim. fallita", !esito);
    elimina(l, 0, esito);
    assert("Elim. riuscita", esito);
    assert("Lista vuota", listaVuota(l));
    aggiungi(l, 20, esito);
    aggiungi(l, 30, esito);
    aggiungi(l, 40, esito);
    assert("Tre elementi", numeroElementi(l) == 3);
    elimina(l, 0, esito);
    assert("Elim. riuscita", esito);
    assert("Due elementi", numeroElementi(l) == 2);
    assert("Cerca 20", cercaPosizione(l, 20) == -1);
    assert("Valore 30", elementoInPosizione(l, 0) == 30);
    assert("Valore 40", elementoInPosizione(l, 1) == 40);
    elimina(l, 1, esito);
    assert("Elim. riuscita", esito);
    assert("Un elemento", numeroElementi(l) == 1);
    assert("Cerca 40", cercaPosizione(l, 40) == -1);
    assert("Valore 30", elementoInPosizione(l, 0) == 30);
    elimina(l, 0, esito);
    assert("Elim. riuscita", esito);
    assert("Lista vuota", listaVuota(l));
    return;
}

void testCarica1() {
    cout << "\ntestCarica1 - lista non vuota" << endl;
    bool esito;
    lista l;
    carica(l, "listaPtrTest1.txt");
    assert("Tre elementi", numeroElementi(l) == 3);
    assert("Valore 30", elementoInPosizione(l, 0) == 30);
    assert("Valore 40", elementoInPosizione(l, 1) == 40);
    assert("Valore 50", elementoInPosizione(l, 2) == 50);
    return;
}

void testCarica2() {
    cout << "\ntestCarica2 - lista vuota" << endl;
    bool esito;
    lista l;
    carica(l, "fileInesistente.txt");
    assert("Lista vuota", listaVuota(l));
    return;
}

void main() {
    testInizializza();
    testListaPiena();
    testAggiungiInTesta1();
    testAggiungiInTesta2();
    testPuntatoreAllUltimo1();
    testPuntatoreAllUltimo2();
    testAggiungiInCoda1();
    testAggiungiInCoda2();
    testAggiungiInPosizione1();
    testAggiungiInPosizione2();
    testAggiungiInPosizione3();
    testEliminaInCoda1();
    testEliminaInCoda2();
    testEliminaInCoda3();
    testEliminaInPosizione1();
    testEliminaInPosizione2();
    testCarica1();
    testCarica2();
}