#include <iostream.h>
#include <fstream.h>

struct partita {
    string squadraCasa, squadraTrasferta;
    int goalCasa, goalTrasferta;
    char segno;
};

const int N = 9;

void schermoMenu(int& scelta);
void leggiPartite(partita partite[N]);
void leggiPartita(partita &p);
void stampaPartite(partita partite[N]);
void stampaPartita(partita p);
void calcolaSegni(partita partite[N]);
void leggiDaFile(partita partite[N], string nomeFile);
void leggiNomeFile(string &nomeFile);
void salvaSuFile(partita partite[N], string nomeFile);

void main() {
    partita partite[N];
    string nomeFile;
    int scelta;
    bool continua = true;
    while (continua) {
        schermoMenu(scelta);
        if (scelta == 0) {
            continua = false;
        } else if (scelta == 1) {
            leggiPartite(partite);
        } else if (scelta == 2) {
            calcolaSegni(partite);
            stampaPartite(partite);
        } else if (scelta == 3) {
            leggiNomeFile(nomeFile);
            leggiDaFile(partite, nomeFile);
        } else if (scelta == 4) {
            leggiNomeFile(nomeFile);
            salvaSuFile(partite, nomeFile);
        }
    }

}

void schermoMenu (int &scelta) {
    cout << "\n Campionato di Serie A \n";
    cout << "\n Menu Principale\n";
    cout << "-----------------------------------------\n";
    cout << "  1. Leggi da tastiera\n";
    cout << "  2. Calcola segni e stampa sullo schermo\n";
    cout << "  3. Leggi da file\n";
    cout << "  4. Salva su file\n";
    cout << "  \n";
    cout << "  0. Esci\n";
    cout << "-----------------------------------------\n";
    cout << "Immetti scelta --> ";
    cin >> scelta;
    while (scelta < 0 || scelta > 4) {
        cout << "Errore. Immetti scelta -->";
        cin >> scelta;
    }
    cin.ignore();
    return;
}

void leggiPartite(partita partite[N]){
    int i;
    for (i = 0; i < N; i++) {
        leggiPartita(partite[i]);
    }
    return;
}

void leggiPartita(partita &p){
    cout << "\nImmetti i dati della partita\n";
    cout << "Squadra in casa          : ";
    getline(cin, p.squadraCasa);
    cout << "Squadra in trasferta     : ";
    getline(cin, p.squadraTrasferta);
    cout << "Goal squadra in casa     : ";
    cin >> p.goalCasa;
    //cin.ignore();
    cout << "Goal squadra in trasferta: ";
    cin >> p.goalTrasferta;
    cin.ignore();
    return;
}

void calcolaSegni(partita partite[N]){
    int i;
    for (i = 0; i < N; i++) {
        if (partite[i].goalCasa > partite[i].goalTrasferta) {
            partite[i].segno = '1';
        } else if (partite[i].goalCasa < partite[i].goalTrasferta) {
            partite[i].segno = '2';
        } else {
            partite[i].segno = 'X';
        }
    }
    return;
}

void stampaPartite(partita partite[N]){
    int i;
    cout << "\nRisultati della Giornata\n";
    cout << "----------------------------------\n";
    for (i = 0; i < N; i++) {
        stampaPartita(partite[i]);
    }
    return;
}

void stampaPartita(partita p){
    cout << p.squadraCasa << "-" << p.squadraTrasferta << "   ";
    cout << p.goalCasa << "-" << p.goalTrasferta << "   " << p.segno << endl;
    return;
}

void leggiNomeFile(string &nomeFile){
    cout << "\nImmetti il nome del file: ";
    cin >> nomeFile;
    return;
}

void leggiDaFile(partita partite[N], string nomeFile){
    int i;
    ifstream flussoDiLettura (nomeFile.c_str());
    for (i = 0; i < N; i++) {
        flussoDiLettura >> partite[i].squadraCasa;
        flussoDiLettura >> partite[i].squadraTrasferta;
        flussoDiLettura >> partite[i].goalCasa;
        flussoDiLettura >> partite[i].goalTrasferta;
    }
    return;
}

void salvaSuFile(partita partite[N], string nomeFile){
    int i;
    ofstream fUscita (nomeFile.c_str());
    for (i = 0; i < N; i++) {
        fUscita << partite[i].squadraCasa << "\t" << partite[i].squadraTrasferta << "\t";
        fUscita << partite[i].goalCasa << "\t" << partite[i].goalTrasferta << endl;
    }
    return;
}

