/*
  pilaDiReali.h
  ----------------
  file delle intestazioni di una libreria per la gestione di pile
  di numeri reali rappresentate con array e indicatore di riempimento

  Nota: la libreria e' stata scritta esclusivamente a scopo didattico
  http://www.difa.unibas.it/users/gmecca/corsi/informatica
*/

//COSTANTI GLOBALI:
//-----------------
  const int MAXDIM=10000;
  //--> dimensione massima dell'insieme di numeri reali

//MODELLO DI STRUTTURA
  struct pila {
      int indicatore;
      float valori[MAXDIM];
  };

//PROCEDURE E FUNZIONI:
//--------------------

  void inizializza(pila &p);
  //--> crea una pila vuota
  //pila &p --> la pila

  bool vuota(pila p);
  //--> restituisce vero se la pila e' vuota
  //pila p --> la pila

  void push (pila &p, float elem, bool& esito);
  //--> aggiunge "elem" alla pila p se
  //    questo e' possibile; "esito" segnala la riuscita
  //    dell'operazione
  //pila &p --> la pila
  //float elem    --> elemento da aggiungere
  //bool esito--> segnala l'esito dell'operazione

  void pop (pila &p, bool& esito);
  //--> elimina l'ultimo elemento dalla pila p se
  //    questo e' possibile; "esito" segnala la riuscita
  //  dell'operazione
  //pila &p --> la pila
  //bool esito--> segnala l'esito dell'operazione

  float top (pila p);
  //--> restituisce il valore dell'elemento affiorante
  //  della pila; si genera un errore se la pila e' vuota
  //pila &p --> la pila

