#include <iostream.h>

void leggiDatiRettangolo(float &x1, float &y1, float &x2, float &y2);
void stampaDatiRettangolo(float x1, float y1, float x2, float y2);
void stampaQuadrante(float x1, float y1, float x2, float y2);
int quadrante(float x, float y);
float areaSovrapposizione(float x1, float y1, float x2, float y2,
                           float x3, float y3, float x4, float y4);
void stampaRisultato(float superficie);
float lunghezzaSegmentoComune(float z1, float z2, float z3, float z4);
float minimo(float a, float b);
float massimo(float a, float b);

void main() {
    float x1, y1, x2, y2;
    float x3, y3, x4, y4;
    float superficie;
    leggiDatiRettangolo(x1, y1, x2, y2);
    leggiDatiRettangolo(x3, y3, x4, y4);
    stampaDatiRettangolo(x1, y1, x2, y2);
    stampaQuadrante(x1, y1, x2, y2);
    stampaDatiRettangolo(x3, y3, x4, y4);
    stampaQuadrante(x3, y3, x4, y4);
    superficie = areaSovrapposizione(x1, y1, x2, y2, x3, y3, x4, y4);
    stampaRisultato(superficie);
}

void leggiDatiRettangolo(float &x1, float &y1, float &x2, float &y2){
    cout << "Immetti i dati del rettangolo \n";
    cout << "Ascissa del vertice in basso a sinistra in cm  : ";
    cin >> x1;
    cout << "Ordinata del vertice in basso a sinistra in cm : ";
    cin >> y1;
    cout << "Ascissa del vertice in alto a destra in cm     : ";
    cin >> x2;
    cout << "Ordinata del vertice in alto a destra in cm    : ";
    cin >> y2;
    return;
}

void stampaDatiRettangolo(float x1, float y1, float x2, float y2){
    cout << "----------------------------------------\n";
    cout << "   Dati del rettangolo \n";
    cout << "----------------------------------------\n";
    cout << " Vertice in basso a sin.: (" << x1 << "," << y1 << ")\n";
    cout << " Vertice in alto a dx.  : (" << x2 << "," << y2 << ")\n";
    cout << "----------------------------------------\n";
    return;
}

void stampaQuadrante(float x1, float y1, float x2, float y2){
    int q1, q2;
    q1 = quadrante(x1, y1);
    q2 = quadrante(x2, y2);
    cout << "----------------------------------------\n";
    if (q1==q2)
        cout << "Rettangolo nel quadrante n. " << q1 << "\n";
    else
        cout << "Rettangolo a cavallo tra quadranti diversi \n";
    cout << "----------------------------------------\n";
    return;
}

int quadrante(float x, float y) {
    int q;
    if (x>=0 && y>=0)
        q=1;
    else if (x<0 && y>=0)
        q=2;
    else if (x<0 && y<0)
        q=3;
    else
        q=4;
    return q;
}

float areaSovrapposizione(float x1, float y1, float x2, float y2,
                           float x3, float y3, float x4, float y4) {
    float sovrapposizioneBasi;
    float sovrapposizioneAltezze;
    float area=0;
    sovrapposizioneBasi = lunghezzaSegmentoComune(x1, x2, x3, x4);
    sovrapposizioneAltezze = lunghezzaSegmentoComune(y1, y2, y3, y4);
    if (sovrapposizioneBasi>0 && sovrapposizioneAltezze>0)
        area = sovrapposizioneBasi*sovrapposizioneAltezze;
    return area;
}

float lunghezzaSegmentoComune(float z1, float z2, float z3, float z4){
    float lunghezza1, lunghezza2;
    float estremoInferiore, estremoSuperiore;
    float lunghezza;
    lunghezza1 = fabs(z2-z1);
    lunghezza2 = fabs(z4-z3);
    estremoInferiore = minimo(z1, z3);
    estremoSuperiore = massimo(z2, z4);
    lunghezza = lunghezza1+lunghezza2-fabs(estremoSuperiore-estremoInferiore);
    if (lunghezza<0)
        lunghezza=0;
    return lunghezza;
}

float minimo(float a, float b) {
    float min;
    if (a<=b)
        min=a;
    else
        min=b;
    return min;
}

float massimo(float a, float b) {
    float max;
    if (a<=b)
        max=b;
    else
        max=a;
    return max;
}

void stampaRisultato(float superficie) {
    if (superficie>0) {
        cout << "   I due rettangoli hanno in comune\n";
        cout << "   una superficie pari a: " << superficie << "cm quadrati \n";
    } else
        cout << "   I due rettangoli non hanno superficie in comune \n";
    return;
}