#include <iostream.h>

struct punto {
    float x, y;
};

struct rettangolo {
    punto v1, v2;
};

void leggiDatiRettangolo(rettangolo &r);
void stampaDatiRettangolo(rettangolo r);
void stampaQuadrante(rettangolo r);
void stampaRisultato(float superficie);

int quadrante(punto p);
float minimo(float a, float b);
float massimo(float a, float b);
float lunghezzaSegmentoComune(float z1, float z2, float z3, float z4);
float areaSovrapposizione(rettangolo r1, rettangolo r2);

/*
void main() {
    rettangolo r1;
    rettangolo r2;
    float superficie;
    leggiDatiRettangolo(r1);
    leggiDatiRettangolo(r2);
    stampaDatiRettangolo(r1);
    stampaQuadrante(r1);
    stampaDatiRettangolo(r2);
    stampaQuadrante(r2);
    superficie = areaSovrapposizione(r1, r2);
    stampaRisultato(superficie);
}
*/


void leggiDatiRettangolo(rettangolo &r){
    cout << "Immetti i dati del rettangolo \n";
    cout << "Ascissa del vertice in basso a sinistra in cm  : ";
    cin >> r.v1.x;
    cout << "Ordinata del vertice in basso a sinistra in cm : ";
    cin >> r.v1.y;
    cout << "Ascissa del vertice in alto a destra in cm     : ";
    cin >> r.v2.x;
    cout << "Ordinata del vertice in alto a destra in cm    : ";
    cin >> r.v2.y;
    return;
}

void stampaDatiRettangolo(rettangolo r){
    cout << "----------------------------------------\n";
    cout << "   Dati del rettangolo \n";
    cout << "----------------------------------------\n";
    cout << " Vertice in basso a sin.: (" << r.v1.x << "," << r.v1.y << ")\n";
    cout << " Vertice in alto a dx.  : (" << r.v2.x << "," << r.v2.y << ")\n";
    cout << "----------------------------------------\n";
    return;
}

void stampaQuadrante(rettangolo r){
    int q1, q2;
    q1 = quadrante(r.v1);
    q2 = quadrante(r.v2);
    cout << "----------------------------------------\n";
    if (q1 == q2) {
        cout << "Rettangolo nel quadrante n. " << q1 << "\n";
    } else {
        cout << "Rettangolo a cavallo tra quadranti diversi \n";
    }
    cout << "----------------------------------------\n";
    return;
}

int quadrante(punto p) {
    int q;
    if (p.x >= 0 && p.y >= 0) {
        q = 1;
    } else if (p.x < 0 && p.y >= 0) {
        q = 2;
    } else if (p.x < 0 && p.y < 0) {
        q = 3;
    } else {
        q = 4;
    }
    return q;
}

float areaSovrapposizione(rettangolo r1, rettangolo r2) {
    float sovrapposizioneBasi;
    float sovrapposizioneAltezze;
    float area=0;
    sovrapposizioneBasi = lunghezzaSegmentoComune(r1.v1.x, r1.v2.x, r2.v1.x, r2.v2.x);
    sovrapposizioneAltezze = lunghezzaSegmentoComune(r1.v1.y, r1.v2.y, r2.v1.y, r2.v2.y);
    if (sovrapposizioneBasi > 0 && sovrapposizioneAltezze > 0) {
        area = sovrapposizioneBasi*sovrapposizioneAltezze;
    }
    return area;
}

float lunghezzaSegmentoComune(float z1, float z2, float z3, float z4){
    float lunghezza1, lunghezza2;
    float estremoInferiore, estremoSuperiore;
    float lunghezza;
    lunghezza1 = fabs(z2 - z1);
    lunghezza2 = fabs(z4 - z3);
    estremoInferiore = minimo(z1, z3);
    estremoSuperiore = massimo(z2, z4);
    lunghezza = lunghezza1 + lunghezza2 - fabs(estremoSuperiore-estremoInferiore);
    if (lunghezza < 0) {
        lunghezza = 0;
    }
    return lunghezza;
}

float minimo(float a, float b) {
    float min;
    if (a <= b) {
        min = a;
    } else {
        min = b;
    }
    return min;
}

float massimo(float a, float b) {
    float max;
    if (a <= b) {
        max = b;
    } else {
        max = a;
    }
    return max;
}

void stampaRisultato(float superficie) {
    if (superficie > 0) {
        cout << "   I due rettangoli hanno in comune\n";
        cout << "   una superficie pari a: " << superficie << "cm quadrati \n";
    } else {
        cout << "   I due rettangoli non hanno superficie in comune \n";
    }
    return;
}