#include "rettangoli2.cpp"

void assert(string s, bool asserzione) {
    if (!asserzione) {
        cout << "\n ****Errore: " << s << endl;
        //exit(1);
    } else {
        cout << ".";
    }
    return;
}


void testQuadrante1() {
    cout << "\n**testQuadrante1\n";
    int q;
    punto p;
    p.x = 1;
    p.y = 2;
    q = quadrante(p);
    assert("Test n.1 - quadrante", q == 1);
    p.x = 0;
    p.y = 2;
    q = quadrante(p);
    assert("Test n.2 - quadrante", q == 1);
    p.x = 0;
    p.y = 0;
    q = quadrante(p);
    assert("Test n.3 - quadrante", q == 1);
    return;
}

void testQuadrante2() {
    cout << "\n**testQuadrante2\n";
    int q;
    punto p;
    p.x = -1;
    p.y = 2;
    q = quadrante(p);
    assert("Test n.4 - quadrante", q == 2);
    p.x = -2.5;
    p.y = 0;
    q = quadrante(p);
    assert("Test n.5 - quadrante", q == 2);
    return;
}

void testQuadrante3() {
    cout << "\n**testQuadrante3\n";
    int q;
    punto p;
    p.x = -1;
    p.y = -2.5;
    q = quadrante(p);
    assert("Test n.6 - quadrante", q == 3);
    return;
}

void testQuadrante4() {
    cout << "\n**testQuadrante4\n";
    int q;
    punto p;
    p.x = 2.3;
    p.y = -4;
    q = quadrante(p);
    assert("Test n.7 - quadrante", q == 4);
    p.x = 0;
    p.y = -4;
    q = quadrante(p);
    assert("Test n.8 - quadrante", q == 4);
    return;
}

void testMinimo1() {
    cout << "\n**testMinimo1\n";
    float m;
    m = minimo(2, 5);
    assert("Test n.1 - minimo", m == 2);
    m = minimo(2, 0);
    assert("Test n.2 - minimo", m == 0);
    m = minimo(-2, -2);
    assert("Test n.3 - minimo", m == -2);
    return;
}

void testMassimo1() {
    cout << "\n**testMassimo1\n";
    float m;
    m = massimo(2, 5);
    assert("Test n.1 - massimo", m == 5);
    m = massimo(2, 0);
    assert("Test n.2 - massimo", m == 2);
    m = massimo(-2, -2);
    assert("Test n.3 - massimo", m == -2);
    return;
}

void testLunghezzaSegmentoComune1() {
    cout << "\n**testLunghezzaSegmentoComune1\n";
    float l;
    l = lunghezzaSegmentoComune(-1, 2, 1, 2);
    assert("Test n.1 - lunghezzaSegmentoComune", l == 1);
    l = lunghezzaSegmentoComune(-5, -3, -7, 1);
    assert("Test n.2 - lunghezzaSegmentoComune", l == 2);
    return;
}

void testLunghezzaSegmentoComune2() {
    cout << "\n**testLunghezzaSegmentoComune2\n";
    float l;
    l = lunghezzaSegmentoComune(-1, 1, 2, 2);
    assert("Test n.1 - lunghezzaSegmentoComune", l == 0);
    l = lunghezzaSegmentoComune(-1, 1, 1, 2);
    assert("Test n.2 - lunghezzaSegmentoComune", l == 0);
    return;
}

void testAreaSovrapposizione1() {
    cout << "\n**testAreaSovrapposizione1\n";
    rettangolo r1 = {{1, 2}, {7, 6}};
    rettangolo r2 = {{3, 1}, {8, 5}};
    float area;
    area = areaSovrapposizione(r1, r2);
    assert("Test area n.1", area == 12);
    return;
}

void testAreaSovrapposizione2() {
    cout << "\n**testAreaSovrapposizione2\n";
    rettangolo r1 = {{-2, 3.5}, {3, 5.5}};
    rettangolo r2 = {{2, 1}, {6.2, 3}};
    float area;
    area = areaSovrapposizione(r1, r2);
    assert("Test area n.2", area == 0);
    return;
}

void testAreaSovrapposizione3() {
    cout << "\n**testAreaSovrapposizione3\n";
    rettangolo r1 = {{-1, 1}, {7, 6}};
    rettangolo r2 = {{3, 2}, {6, 5}};
    float area;
    area = areaSovrapposizione(r1, r2);
    assert("Test area n.3", area == 9);
    return;
}

void testAreaSovrapposizione4() {
    cout << "\n**testAreaSovrapposizione4\n";
    rettangolo r1 = {{-2, 1}, {3, 5.5}};
    rettangolo r2 = {{3, 1}, {7.2, 3}};
    float area;
    area = areaSovrapposizione(r1, r2);
    assert("Test area n.4", area == 0);
    return;
}

void testAreaSovrapposizione5() {
    cout << "\n**testAreaSovrapposizione5\n";
    rettangolo r1 = {{-1, 1}, {7, 6}};
    rettangolo r2 = {{4, 2}, {7, 5}};
    float area;
    area = areaSovrapposizione(r1, r2);
    assert("Test area n.5", area == 9);
    return;
}

void testAreaSovrapposizione6() {
    cout << "\n**testAreaSovrapposizione6\n";
    rettangolo r1 = {{-2, 3}, {3, 5.5}};
    rettangolo r2 = {{3, 1}, {7.2, 3}};
    float area;
    area = areaSovrapposizione(r1, r2);
    assert("Test area n.6", area == 0);
    return;
}

void testAreaSovrapposizione7() {
    cout << "\n**testAreaSovrapposizione7\n";
    rettangolo r1 = {{0, 0}, {0, 0}};
    rettangolo r2 = {{3, 1}, {7.2, 3}};
    float area;
    area = areaSovrapposizione(r1, r2);
    assert("Test area n.7", area == 0);
    return;
}

void testAreaSovrapposizione8() {
    cout << "\n**testAreaSovrapposizione8\n";
    rettangolo r1 = {{0, 0}, {0, 0}};
    rettangolo r2 = {{0, 0}, {0, 0}};
    float area;
    area = areaSovrapposizione(r1, r2);
    assert("Test area n.8", area == 0);
    return;
}

void main() {
    testQuadrante1();
    testQuadrante2();
    testQuadrante3();
    testQuadrante4();
    testMinimo1();
    testMassimo1();
    testLunghezzaSegmentoComune1();
    testLunghezzaSegmentoComune2();
    testAreaSovrapposizione1();
    testAreaSovrapposizione2();
    testAreaSovrapposizione3();
    testAreaSovrapposizione4();
    testAreaSovrapposizione5();
    testAreaSovrapposizione6();
    testAreaSovrapposizione7();
    testAreaSovrapposizione8();
}