#include <iostream.h>
#include <fstream.h>

struct studente {
    int matricola;
    string cognome, nome;
    int annoCorso;
};

const int N=100;

struct listaStudenti {
    int indicatore;
    studente dati[N];
};

void carica(listaStudenti &ls, string nomeFile);
void leggiNomeFile(string &nomeFile);
void stampa(listaStudenti studenti);
void stampaDatiStudente(studente s);
void cercaStudente(listaStudenti studenti);
int cercaPosizione(listaStudenti studenti, int matricola);
void leggiDatiStudente(studente &s);
void aggiungiInCoda(listaStudenti &studenti, studente s, bool &esito);

void main() {
    listaStudenti studenti;
    string nomeFile;
    studente s;
    bool esito;

    leggiNomeFile(nomeFile);
    carica(studenti, nomeFile);
    stampa(studenti);
    cercaStudente(studenti);
    leggiDatiStudente(s);
    aggiungiInCoda(studenti, s, esito);
    if (esito) {
        cout << "Aggiunta effettuata correttamente\n";
        stampa(studenti);
    } else {
        cout << "Aggiunta impossibile\n";
    }
}

void leggiNomeFile(string &nomeFile){
    cout << "\nImmetti il nome del file: ";
    cin >> nomeFile;
    return;
}

void carica(listaStudenti &studenti, string nomeFile){
    int i;
    ifstream flussoDiLettura (nomeFile.c_str());
    i=0;
    while (flussoDiLettura >> studenti.dati[i].matricola) {
        flussoDiLettura.ignore();
        getline(flussoDiLettura, studenti.dati[i].cognome);
        getline(flussoDiLettura, studenti.dati[i].nome);
        flussoDiLettura >> studenti.dati[i].annoCorso;
        i++;
    }
    studenti.indicatore = i;
    return;
}

void stampa(listaStudenti studenti){
    int i;
    cout << "\nDati degli studenti\n";
    cout << "----------------------------------\n";
    if (studenti.indicatore==0)
        cout << "Lista vuota\n\n";
    else
        for (i=0; i<studenti.indicatore; i++) {
            stampaDatiStudente(studenti.dati[i]);
            cout << endl;
        }
    return;
}

void stampaDatiStudente(studente s){
    cout << "Matricola: " << s.matricola << endl;
    cout << "Cognome:   " << s.cognome << endl;
    cout << "Nome:      " << s.nome << endl;
    cout << "Anno:      " << s.annoCorso << endl;
    return;
}

void leggiDatiStudente(studente &s){
    cout << "\nImmetti i dati del nuovo studente\n\n";
    cout << "Matricola: ";
    cin >> s.matricola;
    cout << "Cognome:   ";
    cin.ignore();
    getline(cin, s.cognome);
    cout << "Nome:      ";
    getline(cin, s.nome);
    cout << "Anno:      ";
    cin >> s.annoCorso;
    return;
}

void cercaStudente(listaStudenti studenti) {
    int matricola, pos;
    cout << "Immetti la matricola da cercare: ";
    cin >> matricola;
    pos = cercaPosizione(studenti, matricola);
    if (pos!=-1)
        stampaDatiStudente(studenti.dati[pos]);
    else
        cout << "Matricola non presente\n";
    return;
}


int cercaPosizione(listaStudenti studenti, int matricola){
    int pos, i;
    bool trovato = false;
    pos=-1;
    i=0;
    while (!trovato && i<studenti.indicatore)
        if (studenti.dati[i].matricola==matricola){
            pos=i;
            trovato=true;
        } else
            i++;
    return pos;
}

void aggiungiInCoda(listaStudenti &studenti, studente s, bool &esito){
   if (studenti.indicatore==N)
       esito=false;
   else {
       studenti.dati[studenti.indicatore] = s;
       studenti.indicatore++;
       esito = true;
   }
   return;
}
